/*
   CONSOLE.C

   Ein-/Ausgabe auf der Konsole taetigen (so vorhanden)

   8.7.95    Till  erste Version
   27.11.96  Chip  Typen auf tm_* umgestellt
*/

#include "machine.h"
#include "console.h"

#ifdef MACHINE_HAS_CONSOLE
#include <stdio.h>
#include <stdarg.h>
#endif

tm_void console_printf(tm_char *fmt, ...) 
{
#ifdef MACHINE_HAS_CONSOLE
  va_list args;
  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  va_end(args);
#else
  (tm_void)fmt;
#endif  
}

/* String auf Console ausgeben */
tm_void console_puts(tm_char *string)
{
#ifdef MACHINE_HAS_CONSOLE
   fputs(string,stderr);
   fputs("\n",stderr);
#else
  (tm_void)string;
#endif
}

tm_void console_waitkey(tm_void)
{
#ifdef MACHINE_HAS_CONSOLE
  (tm_void)getchar();
#endif
}
