/*
   CTYPES.H

   Sieht man doch!

   Historie:
   8.7.95    Till  erste Version
   3.1.96    Till  uint und ushort kollidieren mit X11 -> tm_...
   27.11.96  Chip  Ueberall Typen auf tm_* umgestellt, etwas aufgeraeumt
   28.11.96  Chip  Typen auf tm_* umgestellt
   25.01.98  Till  CONST mit ifdef
*/

#ifndef __CTYPES__
#define __CTYPES__
#include "machine.h"

#ifdef __TURBOC__    /* def'd in TC & BC */
#define BEST16
#endif

#ifdef __TOS__       /* mostly a 16 bit machine */
#define BEST16
#endif

#ifndef CONST
#if defined(__TURBOC__) && !defined(__BORLANDC__) && !defined(__TOS__)
#define CONST          /* TurboC does not like const */
#else
#define CONST const
#endif
#endif

/* TheMaze Datentypen */
typedef          char    tm_char;
typedef unsigned char    tm_uchar;
typedef          char    tm_byte;
typedef unsigned char    tm_ubyte;
typedef          short   tm_short;
typedef unsigned short   tm_ushort;
typedef          long    tm_long;
typedef unsigned long    tm_ulong;
typedef unsigned char    tm_bool;
typedef          tm_bool tm_bit;
typedef          void    tm_void;

/* das Beste fuer die Maschine muss mindestens 16 Bit haben... */
#if defined(BEST16)
typedef          short   tm_word;
typedef unsigned short   tm_uword;
#else
typedef          long    tm_word;
typedef unsigned long    tm_uword;
#endif

/* diverse defines */
#ifndef FALSE
#define FALSE (0)
#endif
#ifndef TRUE
#define TRUE  (!FALSE)
#endif
#define ERROR (0)
#define OK    (!ERROR)
#define NO    (0)
#define YES   (!NO)
#define OFF   (0)
#define ON    (!OFF)

#ifndef MIN
#define MIN(a,b)  ((a<b)?a:b)
#endif
#ifndef MAX
#define MAX(a,b)  ((a>b)?a:b)
#endif

#define NULL_PTR  ((tm_void*)0l)

#endif /* __CTYPES__ */
/* hier ist Ende, hier darf nix hinter kommen !!! */
