/*
  timer.c

  PIT8253-Timer-Treiber fr PC

  18.7.95  Till   erste Version fuer Borland C
  21.6.96  Till   umgestellt auf eigenen Interrupt-Handler
     1.97  Till   umgestellt auf DJGPP
   3.2.97  Till   Borland C ganz rausgeschmissen
   7.2.97  Till   LibHW-Bibliothek
*/

char timer_driver_name[]="BIOS timer V1.2";

#include "ctypes.h"
#include "timer.h"
#include "misc.h"
#include <dos.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <pc.h>
#include <go32.h>
#include <dpmi.h>
#include <sys/lock.h>
#include <sys/timer.h>

/* Frequenzen festlegen */
#define FREQ  100       /* 20 .. 1000 Hertz */

/* global counter */
void my_func() __attribute__ ((LOCKED_FUNC));
volatile tm_ulong timer __attribute__ ((LOCKED_VAR));

void my_func() {
  timer++;
}

tm_uword init_timer(void)
{
  __dpmi_regs regs;

  /* Zufallszahlen initialisieren */
  regs.h.ah = 0;
  __dpmi_int(0x1a,&regs);
  srnd((((tm_ulong)regs.x.cx)<< 16) + regs.x.dx);
  
  timer=0;

  lock_sections();
  init_vects();
  timer_handler(my_func);
   
  timer_setup(0,2,TIMER_CLOCK/FREQ); /* 100Hz operation */

  atexit(exit_timer);

  return(OK);
}

tm_void exit_timer(tm_void)
{
  /* Originalzustand herstellen */
  timer_setup(0,2,0);
  timer_handler(0);
}

tm_ulong get_ticks(void)
{
  return(timer);
}

tm_ulong ticks2msec(tm_ulong ticks)
{
  return(ticks*(1000/FREQ));
}

tm_ulong msec2ticks(tm_ulong msec)
{
  return(msec/(1000/FREQ));
}

