/*
   drawmap.c

   09.03.97  Chip   aus maze.c extrahiert
                    und angepasst
   13.07.97  Chip   nur noch eine Spielerliste
*/

#include "ctypes.h"
#include "mazes.h"
#include "maze.h"
#include "drawmap.h"
#include "gr_prim.h"
#include "grafik.h"
#include "move.h"
#include "ninja.h"
#include "machine.h"
#include "net.h"

tm_uword  map_color[OB_MASK+1];

static  tm_word  xx[MAX_MAZE],xy[MAX_MAZE],yx[MAX_MAZE],yy[MAX_MAZE];

tm_void draw_map(tm_void)
{
  tm_long   sin,cos;
  tm_word   i,j,mx,my,scale;
  tm_uword  d;
  tm_word   x,y,px,py;

  draw_rect(0,0,width,pf_height,COL_BLACK);

  cos=costab[player[my_id].rot_z>>4];
  sin=sintab[player[my_id].rot_z>>4];

  mx=akt_maze->x_size-1;
  for (i=0; i<=mx; i++)
  {
    xx[i]=((i+i-mx)*cos)>>(15-7);
    xy[i]=((i+i-mx)*sin)>>(15-7);
  }
  my=akt_maze->y_size-1;
  for (j=0; j<=my; j++)
  {
    yx[j]=((my-j-j)*sin)>>(15-7);
    yy[j]=((j+j-my)*cos)>>(15-7);
  }

  scale=(128*((mx>my?mx:my)+1)*3)/(width>pf_height?pf_height:width);

  /* alles vorbereitet, jetzt die Linien malen */
  for (i=0; i<=mx; i++)
    for (j=0; j<=my; j++)
    {
      d=akt_maze->data[j*akt_maze->x_size+i];
      if (d & (OB_MASK<<OB_X_SHIFT))
        draw_line(width/2+(xx[i  ]+yx[j  ])/scale,pf_height/2-(xy[i  ]+yy[j  ])/scale,
                  width/2+(xx[i+1]+yx[j  ])/scale,pf_height/2-(xy[i+1]+yy[j  ])/scale,
                  map_color[(d>>OB_X_SHIFT)&OB_MASK]);
      if (d & (OB_MASK<<OB_Y_SHIFT))
        draw_line(width/2+(xx[i  ]+yx[j  ])/scale,pf_height/2-(xy[i  ]+yy[j  ])/scale,
                  width/2+(xx[i  ]+yx[j+1])/scale,pf_height/2-(xy[i  ]+yy[j+1])/scale,
                  map_color[(d>>OB_Y_SHIFT)&OB_MASK]);
      if (d & OB_FILLED)
      {
        draw_line(width/2+(xx[i  ]+yx[j  ])/scale,pf_height/2-(xy[i  ]+yy[j  ])/scale,
                  width/2+(xx[i+1]+yx[j+1])/scale,pf_height/2-(xy[i+1]+yy[j+1])/scale,
                  map_color[OB_NOTHING]);
        draw_line(width/2+(xx[i+1]+yx[j  ])/scale,pf_height/2-(xy[i+1]+yy[j  ])/scale,
                  width/2+(xx[i  ]+yx[j+1])/scale,pf_height/2-(xy[i  ]+yy[j+1])/scale,
                  map_color[OB_NOTHING]);
      }
    }

  /* Spieler malen */
  for(i=0;i<players;i++) {
    x=player[i].x - mx*128;
    y=player[i].y - my*128;
    px=(x*cos-y*sin)>>15;
    py=(x*sin+y*cos)>>15;
    draw_disc(width/2+px/scale, pf_height/2-py/scale, 60/scale, player[i].col, COL_WHITE);
  }

  /* Fadenkreuz */
  x=player[my_id].x - mx*128;
  y=player[my_id].y - my*128;
  px=(x*cos-y*sin)>>15;
  py=(x*sin+y*cos)>>15;
  draw_hline(0,pf_height/2-py/scale,width,(colors<16)?BW_MGRAY:COL_DGRAY);
  draw_vline(width/2+px/scale,0,pf_height,(colors<16)?BW_MGRAY:COL_DGRAY);

  draw_compass(player[my_id].rot_z);

  flip_screen();
}
