/*
  error.c

  ???       Till  erste version
  14.11.96  Chip  bombenbild korrigiert, put_bitmap nur durchsichtig
  14.11.96  Chip  korrekte Farben fuer Monochrom-Schirme
  26.11.96  Chip  put_bitmap mit 16 bit
  27.11.96  Chip  Typen auf tm_* umgestellt
*/

#include "ctypes.h"
#include "gr_prim.h"
#include "error.h"
#include "grafik.h"
#include "misc.h"
#include "console.h"

static tm_ushort atari_bombs[]={
#ifdef __TOS__
  0x0600,   /* .....**......... */
  0x2900,   /* ..*.*..*........ */
  0x0080,   /* ........*....... */
  0x4840,   /* .*..*....*...... */
  0x11f0,   /* ...*...*****.... */
  0x0110,   /* .......*...*.... */
  0x060c,   /* .....**.....**.. */
  0x09b2,   /* ....*..**.**..*. */
  0x09b2,   /* ....*..**.**..*. */
  0x11b1,   /* ...*...**.**...* */
  0x1001,   /* ...*...........* */
  0x0a0a,   /* ....*.*.....*.*. */
  0x09f2,   /* ....*..*****..*. */
  0x0404,   /* .....*.......*.. */
  0x0318,   /* ......**...**... */
  0x00e0 }; /* ........***..... */
#else
  0x0600,   /* .....**......... */
  0x2900,   /* ..*.*..*........ */
  0x0080,   /* ........*....... */
  0x4840,   /* .*..*....*...... */
  0x11f0,   /* ...*...*****.... */
  0x01f0,   /* .......*****.... */
  0x07fc,   /* .....*********.. */
  0x0ffe,   /* ....***********. */
  0x0dfe,   /* ....**.********. */
  0x1fff,   /* ...************* */
  0x1fef,   /* ...********.**** */
  0x0fee,   /* ....*******.***. */
  0x0fde,   /* ....******.****. */
  0x07fc,   /* .....*********.. */
  0x03f8,   /* ......*******... */
  0x00e0 }; /* ........***..... */
#endif

/* do some atari-st bombs */
tm_void atari_error(tm_uword no, tm_char *msg)
{
  tm_uword i;

  console_puts(msg);

  if (no!=0)
    draw_rect(0,height/2-8,16*no,16,colors<16 ? BW_WHITE:COL_WHITE);
  for(i=0;i<no;i++)
    put_bitmap(16*i,height/2-8,16,16,atari_bombs,colors<16 ? BW_BLACK:COL_BLACK);

  flip_screen();
}

tm_void do_error(tm_uword no, tm_char *msg) 
{
  atari_error(no, msg);
}
