/* 
   config.h

   Diese Datei gaukelt dem pk.c vom xdvi vor, dass er daheim waere!
   Das ermoeglicht den einfachen Wechsel auf neue/andere Fonr-Formate,
   die xdvi beherscht (z.B. *.GF).

   Historie:
   Anfang Mai Till erste Version
   26.11.96   Chip Anpassung an Pure-C, damit er nicht so meckert
*/

#include <stdio.h>

#define noMSBITFIRST     /* define MSBITFIRST if MSB is on left side */

#define	BMUNIT			unsigned char
#define	BYTES_PER_BMUNIT	sizeof(BMUNIT)
#define	BITS_PER_BMUNIT		(8*BYTES_PER_BMUNIT)
#define	ADD(a, b)	((BMUNIT *) (((char *) a) + b))
#define	SUB(a, b)	((BMUNIT *) (((char *) a) - b))

#define one(fp)		((unsigned char) getc(fp))
#define sone(fp)	((long) one(fp))
#define two(fp)		num (fp, 2)
#define stwo(fp)	snum(fp, 2)
#define four(fp)	num (fp, 4)
#define sfour(fp)	snum(fp, 4)

#define ROUNDUP(x,y) (((x)+(y)-1)/(y))
#define Fprintf    fprintf
#define Printf     printf
#define Fseek      fseek
#define Putchar    putchar
#define Putc       putc
#define Fclose     fclose
#define Fread      fread

#define	DBG_PK		0x4

typedef unsigned char ubyte;
typedef char Boolean;
typedef	ubyte		wide_ubyte;
typedef	int		wide_bool;

extern  int debug;
extern	BMUNIT	bit_masks[BITS_PER_BMUNIT + 1];

struct bitmap {
	unsigned short	w, h;		/* width and height in pixels */
	short		bytes_wide;	/* scan-line width in bytes */
	char		*bits;		/* pointer to the bits */
};

struct glyph {
	long addr;		/* address of bitmap in font file */
	long dvi_adv;		/* DVI units to move reference point */
	short x, y;		/* x and y offset in pixels */
	struct bitmap bitmap;	/* bitmap for character */
	short x2, y2;		/* x and y offset in pixels (shrunken bitmap) */
	struct bitmap bitmap2;	/* shrunken bitmap for character */
};

struct tn { short dummy; };
struct macro { short dummy; };

struct font {
	struct font *next;		/* link to next font info block */
	char *fontname;			/* name of font */
	float fsize;			/* size information (dots per inch) */
	int magstepval;			/* magstep number * two, or NOMAGSTP */
	FILE *file;			/* open font file or NULL */
	char *filename;			/* name of font file */
	long checksum;			/* checksum */
	unsigned short timestamp;	/* for LRU management of fonts */
	ubyte flags;			/* flags byte (see values below) */
	ubyte maxchar;			/* largest character code */
	double dimconv;			/* size conversion factor */
#ifdef __TOS__
	void (*read_char)(register struct font *fontp, wide_ubyte ch);
#else
        void (*read_char)();
#endif					/* function to read bitmap */
	struct glyph *glyph;
		/* these fields are used by (loaded) virtual fonts */
	struct font **vf_table;		/* list of fonts used by this vf */
	struct tn *vf_chain;		/* ditto, if TeXnumber >= VFTABLELEN */
	struct font *first_font;	/* first font defined */
	struct macro *macro;
		/* I suppose the above could be put into a union, but we */
		/* wouldn't save all that much space. */
};

#ifdef __TOS__
/* aus pk.c : */
static int PK_get_nyb(register FILE *fp);
static int PK_packed_num(register FILE *fp);
static void PK_skip_specials(register struct font *fontp);
extern void read_PK_index(register struct font	*fontp,wide_bool hushcs);

/* aus util.c : */
extern void oops(const char *message, ...);
extern char *xmalloc(unsigned int size, const char *why);
extern void alloc_bitmap(register struct bitmap *bitmap);
extern unsigned long num(register FILE *fp,register int size);
extern long snum(register FILE *fp,register int size);
extern void bzero(char *p,int n);
#endif
