/*
   util.c

   Sinnvolle Funktionen fuer pk.c und makefont.c

   ???       Till  Erste Version
   27.11.96  Chip  Erweitert fuer TOS
*/

#include <stdlib.h>
#ifdef __TOS__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include "config.h"

BMUNIT  bit_masks[] = {
        0x0,            0x1,            0x3,            0x7,
        0xf,            0x1f,           0x3f,           0x7f,
        0xff
};

#ifdef __TOS__
void oops(const char *message, ...)
#else
void oops(va_alist)
     va_dcl
#endif
{
        va_list args;
	char *msg;

        Fprintf(stderr, "makefont: ");
#ifdef __TOS__
        va_start(args,message);
        (void)message;
#else
        va_start(args);
#endif
        msg = va_arg(args, char *);
        (void) vfprintf(stderr, msg, args);
        va_end(args);
        Putc('\n', stderr);
        exit(1);
}

char *xmalloc(unsigned size, const char *why)
{
	/* Avoid malloc(0), though it's not clear if it ever actually
	   happens any more.  */
	char *mem = malloc(size ? size : 1);

	if (mem == NULL)
	    oops("! Cannot allocate %u bytes for %s.\n", size, why);
	return mem;
}

/*
 *	Allocate bitmap for given font and character
 */

void
alloc_bitmap(bitmap)
	register struct bitmap *bitmap;
{
	register unsigned int	size;

	/* width must be multiple of 16 bits for raster_op */
	bitmap->bytes_wide = ROUNDUP((int) bitmap->w, BITS_PER_BMUNIT) *
	    BYTES_PER_BMUNIT;
	size = bitmap->bytes_wide * bitmap->h;
	bitmap->bits = xmalloc(size != 0 ? size : 1, "character bitmap");
}

/*
 *
 *      Read size bytes from the FILE fp, constructing them into a
 *      signed/unsigned integer.
 *
 */

unsigned long
num(fp, size)
	register FILE *fp;
	register int size;
{
	register long x = 0;

	while (size--) x = (x << 8) | one(fp);
	return x;
}

long
snum(fp, size)
	register FILE *fp;
	register int size;
{
	register long x;

#ifdef	__STDC__
	x = (signed char) getc(fp);
#else
	x = (unsigned char) getc(fp);
	if (x & 0x80) x -= 0x100;
#endif
	while (--size) x = (x << 8) | one(fp);
	return x;
}

#ifdef __TOS__
void bzero(char *p,int n)
{
  while (n--)
    *p++=0;
}
#endif
