/*
   GRAFIK.H

   Historie:
   8.7.95    Till  erste Version
   14.11.96  Chip  put_bitmap nur durchsichtig
   14.11.96  Chip  korrekte Farben fuer Monochrom-Schirme
   26.11.96  Chip  put_bitmap mit 16 bit
   27.11.96  Chip  Typen auf tm_* umgestellt
   20.01.97  Chip  Grauraster fuer Schwarz/Weiss
   08.03.97  Chip  eigene Wandfunktionen im Bildschirmtreiber
   10.09.97  Till  hardwareabhaengige Teile in gr_prim.h
*/

#ifndef __GRAFIK__
#define __GRAFIK__

#ifndef __CTYPES__
#include "ctypes.h"
#endif

/* for colorly handicaped machines, b&w patterns */
#define BW_BLACK      0
#define BW_WHITE      1

#define BW_DGRAY      2      /* both for english and american people */
#define BW_DGREY      2
#define BW_MGRAY      3
#define BW_MGREY      3
#define BW_LGRAY      4
#define BW_LGREY      4

#define BW_PATTERN    5      /* first index to pattern */
/* 5  very dark gray/grey        */
/* 6  very light gray/grey       */
/* 7  dark kilt                  */
/* 8  light kilt                 */
/* 9  crossbar horizontal dark   */
/* 10 crossbar diagonal dark     */
/* 11 crossbar horizontal light  */
/* 12 crossbar diagonal light    */
/* 13 checkered horizontal       */
/* 14 checkered diagonal         */
/* 15 smiley (white on black)    */
#define BW_LAST_COL  15      /* last color number */

/* for machines with at least 16 colors */
#define COL_BLACK     0
#define COL_WHITE     1
#define COL_RED       2
#define COL_GREEN     3
#define COL_BLUE      4
#define COL_YELLOW    5
#define COL_MAGENTA   6
#define COL_CYAN      7
#define COL_DGRAY     8
#define COL_DGREY     8
#define COL_LGRAY     9
#define COL_LGREY     9
#define COL_DRED     10
#define COL_DGREEN   11
#define COL_DBLUE    12
#define COL_BROWN    13
#define COL_DMAGENTA 14
#define COL_DCYAN    15

/* colors for shading */
#define COL_VCYAN    64
#define COL_VGREY    128
#define COL_VRED     160
#define COL_VYELLOW  192
#define MSG_TOP 0
#define MSG_BOT 1

typedef struct character{
  tm_uword width,height;
  tm_uword offset,step;
  CONST tm_ushort *data;
} CHARACTER;

extern tm_bool init_screen(tm_uword argc, tm_char **argv);
extern tm_void exit_screen(tm_void);
extern tm_void copy_back_screen(tm_void);

extern tm_void print_message(tm_bool line, tm_char *msg, tm_word color);
extern tm_void draw_text(tm_uword x, tm_uword y, tm_char *string, tm_uword col);
extern tm_void draw_text_width(tm_uword x, tm_uword y, tm_char *string,
                               tm_uword col, tm_uword width);
extern tm_uword get_text_width(tm_char *string);
extern tm_void  draw_compass(tm_ushort);
#ifdef CONSTFONT
extern CONST tm_uword font_height;
extern CONST CHARACTER charTable[128];
#else
extern tm_uword font_height;
extern CHARACTER charTable[128];
#endif
extern tm_uword  width,height,colors, pf_height;

#ifdef TEXTURE
extern tm_bool use_texture;
#endif

#endif /* __GRAFIK__ */
