/*
  joystick.h

  Joystick-Treiber

  12.7.95   Till  erste Version
  27.11.96  Chip  Typen auf tm_* umgestellt
*/

#ifndef __JOYSTICK__
#define __JOYSTICK__

extern tm_char joystick_driver_name[];

extern tm_void init_joystick_options(tm_void);
extern tm_void show_joystick_options(tm_void);
extern tm_bool set_joystick_option(tm_char *cmd);

extern tm_bool init_fkeys(tm_void);
extern tm_void exit_fkeys(tm_void);
extern tm_uword get_fkeys(tm_void);

extern tm_bool init_joystick(tm_void);
extern tm_void exit_joystick(tm_void);
extern tm_uword kind_of_joystick(tm_void);
extern tm_uword get_joystick(tm_void);
extern tm_uword get_joystick_analog(tm_word *x, tm_word *y);

#define JOY_LEFT  (0x01)
#define JOY_RIGHT (0x02)
#define JOY_UP    (0x04)
#define JOY_DOWN  (0x08)
#define JOY_FIRE0 (0x10)
#define JOY_FIRE1 (0x20)
#define JOY_FIRE2 (0x40)
#define JOY_FIRE  (JOY_FIRE0|JOY_FIRE1|JOY_FIRE2)
#define JOY_ALL   (JOY_LEFT|JOY_RIGHT|JOY_UP|JOY_DOWN|JOY_FIRE0|JOY_FIRE1|JOY_FIRE2)

#define NO_FUNKEYS 0
#define FUNKEYS    1

#define NO_DEVICE       0
#define RELATIVE_DEVICE 1
#define ABSOLUTE_DEVICE 2
#define JITTER_DEVICE   4

#endif /* __JOYSTICK__ */
