/* 
   MACHINE.H

   hier sind alle bekannten Maschinen drin und werden ueber vom
   Compiler vorgegebene #define`s erkannt oder ueber #define`s,
   die der User dem Compiler im Makefile mitgibt.

   Historie:
   8.7.95    Till    erste Version
   01.12.96  Chip    erweitert (ST)
   01.03.97  Chip    einige Mal-Optionen hierher
*/

#ifndef __MACHINE__
#define __MACHINE__

/* hier kommen die diversen Maschinen */

#if defined(__MSDOS__)

#define MACHINE_PC_DOS
#define MACHINE 0
#define MACHINE_IS_COMPUTER
#define MACHINE_HAS_FILESYSTEM
#define MACHINE_HAS_CONSOLE
#define noI_KNOW_YOUR_NAME
#define MIN_REZ_WIDTH  (320)
#define MIN_REZ_HEIGHT (200)
#define DEF_REZ_WIDTH  (640)
#define DEF_REZ_HEIGHT (480)
#define MAX_REZ_WIDTH  (1280)
#define MAX_REZ_HEIGHT (1024)
#define noTHREE_D
#define MAX_COLORS     (256)
#define noMULTIMODE
#define noBIG_ENDIAN
#define LITTLE_ENDIAN
#define PICTURES_IN_EXEC
#define PATH_SEP '\\'
#define noWALLS_LINES
#define noWALLS_FILLED
#define WALLS_SHADED
#define TEXTURE
#define USE_MALLOC

#elif defined(__TOS__)

#define MACHINE_ATARI_ST
#define MACHINE 1
#define MACHINE_IS_COMPUTER
#define MACHINE_HAS_FILESYSTEM
#define MACHINE_HAS_CONSOLE
#define I_KNOW_YOUR_NAME
#define MAX_REZ_WIDTH  (640)
#define MAX_REZ_HEIGHT (400)
#define MAX_COLORS     (16)
#define noMULTIMODE
#define BIG_ENDIAN
#define noLITTLE_ENDIAN
#define noTHREE_D
#define noPICTURES_IN_EXEC
#define PATH_SEP '\\'
#define AUDIO_AVAILABLE
#define noAUDIO_VOLUME
#define noAUDIO_BALANCE
#define noWALLS_LINES
#define WALLS_FILLED
#define noWALLS_SHADED
#define noTEXTURE
#define USE_MALLOC
#define CONSTFONT

#elif defined(__DIPLO__)

#define MACHINE_DIPLO
#define MACHINE 2
#define noMACHINE_IS_COMPUTER
#define noMACHINE_HAS_FILESYSTEM
#define noMACHINE_HAS_CONSOLE
#define noI_KNOW_YOUR_NAME
#define MAX_REZ_WIDTH  (640)
#define MAX_REZ_HEIGHT (480)
#define MAX_COLORS     (256)
#define noMULTIMODE
#define BIG_ENDIAN
#define noLITTLE_ENDIAN
#define noTHREE_D
#define noPICTURES_IN_EXEC
#define noPATH_SEP
#define noAUDIO_AVAILABLE
#define noAUDIO_VOLUME
#define noAUDIO_BALANCE
#define noWALLS_LINES
#define noWALLS_FILLED
#define WALLS_SHADED
#define noTEXTURE
#define CONSTFONT

#elif defined(__X11__)

#define MACHINE_X11
#define MACHINE 3
#define MACHINE_IS_COMPUTER
#define MACHINE_HAS_FILESYSTEM
#define MACHINE_HAS_CONSOLE
#define I_KNOW_YOUR_NAME
#define MAX_REZ_WIDTH  (1280)
#define MAX_REZ_HEIGHT (1024)
#define DEF_REZ_WIDTH  (640)
#define DEF_REZ_HEIGHT (480)
#define MIN_REZ_WIDTH  (320)
#define MIN_REZ_HEIGHT (200)
#define MAX_COLORS     (256)
#define MULTIMODE
#define noTHREE_D
#define PICTURES_IN_EXEC
#define PATH_SEP '/'
#define noWALLS_LINES
#define noWALLS_FILLED
#define WALLS_SHADED
#define TEXTURE
#define HAS_CONFIG_FILE
#define USE_MALLOC

/* very funny, ctype.h defines them both */
#undef BIG_ENDIAN
#undef LITTLE_ENDIAN
#include "conf.h"

#endif

#ifndef MACHINE
#error  Sorry, kein bekannter Maschinentyp!
#endif 

#endif /* __MACHINE__ */

