/*
   mathtab.c

   Programm zur Generierung der Sinus/Cosinus/ATan-Tabelle fuer die
   3D-Routinen von Maze.

   12.7.95  Till
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define  SINTAB    "sin_tab.c"

int main(int argc, char *argv[])
{
  float run;
  FILE  *file;
  int   count;
  float sinrez,srun;

  if(argc!=2)
  {
    printf("Usage:  MATHTAB sinrez\n");
    printf("        MATHTAB 256\n");
    return(1);
  }

  sinrez=atof(argv[1]);
  srun=2*M_PI/sinrez;
  
  printf("generiere (Co)Sinus-Tabelle '" SINTAB "' (%d Werte)...\n",(int)sinrez);
  if( (file=fopen(SINTAB,"w"))==NULL)
  {
    printf("Fehler beim Oeffnen von '" SINTAB "'!\n");
    return(1);
  }

  fprintf(file,"/* (Co)Sinus-Tabelle */\n");
  fprintf(file,"#ifdef __X11__\n#include \"../ctypes.h\"\n");
  fprintf(file,"#else\n#include \"ctypes.h\"\n#endif\n");

  fprintf(file,"#define SINTABLEN (0x%04x)\n",(unsigned int)sinrez);
  fprintf(file,"tm_short sintab[]={\n");

  for(count=0,run=0.0;run<(2.5*M_PI);run+=srun)
  {
    fprintf(file,"0x%04x",((int)(32767.0*sin(run))&0xffff));
    if((run+srun)<(2.5*M_PI))
      fprintf(file,", ");
    if(count++==7) {
      fprintf(file,"\n");
      count=0;
    }
  }
  fprintf(file,"};\n\ntm_short *costab=(sintab+0x%04x);\n",(int)sinrez/4);

  /* now the atan(-2...2) */
  fprintf(file,"\ntm_short atantab[]={\n");
  for(count=0,run=-2.0;run<2.0;run+=(4.0/256.0)) {
    fprintf(file,"0x%04x, ",((int)(32767.0/M_PI*atan(run))&0xffff));
    if(count++==7) {
      fprintf(file,"\n");
      count=0;
    }
  }
  fprintf(file,"0x%04x};\n",((int)(32767.0/M_PI*atan(run))&0xffff));

  fclose(file);

  return(0);
}
