/*
  mazes.c

  diese Datei enthaelt fest eingebaute Labys

  22.7.95   Till   erste Version
  27.11.96  Chip   Typen auf tm_* umgestellt
  08.03.97  Chip   etwas komfortabler gestaltet
  25.06.97  Chip   Mazedaten zur Manipulation freigegeben
*/

#include "ctypes.h"
#include "mazes.h"

#define  __  (0                                                    )
#define  _W  (0                              |(OB_WALL<<OB_X_SHIFT))
#define  W_  (0        |(OB_WALL<<OB_Y_SHIFT)                      )
#define  WW  (0        |(OB_WALL<<OB_Y_SHIFT)|(OB_WALL<<OB_X_SHIFT))
#define  _D  (0                              |(OB_DOOR<<OB_X_SHIFT))
#define  D_  (0        |(OB_DOOR<<OB_Y_SHIFT)                      )
#define  DD  (0        |(OB_DOOR<<OB_Y_SHIFT)|(OB_DOOR<<OB_X_SHIFT))
#define  _G  (0                              |(OB_GLAS<<OB_X_SHIFT))
#define  G_  (0        |(OB_GLAS<<OB_Y_SHIFT)                      )
#define  GG  (0        |(OB_GLAS<<OB_Y_SHIFT)|(OB_GLAS<<OB_X_SHIFT))
#define  DW  (0        |(OB_DOOR<<OB_Y_SHIFT)|(OB_WALL<<OB_X_SHIFT))
#define  GW  (0        |(OB_GLAS<<OB_Y_SHIFT)|(OB_WALL<<OB_X_SHIFT))
#define  WD  (0        |(OB_WALL<<OB_Y_SHIFT)|(OB_DOOR<<OB_X_SHIFT))
#define  WG  (0        |(OB_WALL<<OB_Y_SHIFT)|(OB_GLAS<<OB_X_SHIFT))
#define  GD  (0        |(OB_GLAS<<OB_Y_SHIFT)|(OB_DOOR<<OB_X_SHIFT))
#define  DG  (0        |(OB_DOOR<<OB_Y_SHIFT)|(OB_GLAS<<OB_X_SHIFT))

#define F__  (OB_FILLED                                            )
#define F_W  (OB_FILLED                      |(OB_WALL<<OB_X_SHIFT))
#define FW_  (OB_FILLED|(OB_WALL<<OB_Y_SHIFT)                      )
#define FWW  (OB_FILLED|(OB_WALL<<OB_Y_SHIFT)|(OB_WALL<<OB_X_SHIFT))
#define F_D  (OB_FILLED                      |(OB_DOOR<<OB_X_SHIFT))
#define FD_  (OB_FILLED|(OB_DOOR<<OB_Y_SHIFT)                      )
#define FDD  (OB_FILLED|(OB_DOOR<<OB_Y_SHIFT)|(OB_DOOR<<OB_X_SHIFT))
#define F_G  (OB_FILLED                      |(OB_GLAS<<OB_X_SHIFT))
#define FG_  (OB_FILLED|(OB_GLAS<<OB_Y_SHIFT)                      )
#define FGG  (OB_FILLED|(OB_GLAS<<OB_Y_SHIFT)|(OB_GLAS<<OB_X_SHIFT))
#define FDW  (OB_FILLED|(OB_DOOR<<OB_Y_SHIFT)|(OB_WALL<<OB_X_SHIFT))
#define FGW  (OB_FILLED|(OB_GLAS<<OB_Y_SHIFT)|(OB_WALL<<OB_X_SHIFT))
#define FWD  (OB_FILLED|(OB_WALL<<OB_Y_SHIFT)|(OB_DOOR<<OB_X_SHIFT))
#define FWG  (OB_FILLED|(OB_WALL<<OB_Y_SHIFT)|(OB_GLAS<<OB_X_SHIFT))
#define FGD  (OB_FILLED|(OB_GLAS<<OB_Y_SHIFT)|(OB_DOOR<<OB_X_SHIFT))
#define FDG  (OB_FILLED|(OB_DOOR<<OB_Y_SHIFT)|(OB_GLAS<<OB_X_SHIFT))

tm_uchar maze0[]=
     { WW, _W, _W, _W, _W, _W, _W, _W, _W, _W, W_,
       WW, _W, _W, W_,FWW, WW, _W, _W, W_, W_, W_,
       W_, WW, __, __, _W, __, _W, __, __, W_, W_,
       W_, W_, _W, W_, W_, _W, _W, _W, _W, __, W_,
       W_, __, W_, __, W_, __,FWW, W_,FWW, W_, W_,
       W_, _W, _W, W_, W_, __, _W, __, _W, __, W_,
       W_, _W, W_, __, W_, _W, _W, _W, _W, W_, W_,
       W_, W_, _W, __, WW, _W, WW, _W, W_, W_, W_,
       W_, W_, _W, _W, __, W_, __, W_, __, W_, W_,
       W_, _W, _W, W_, _W, _W, _W, _W, _W, __, W_,
       _W, _W, _W, _W, _W, _W, _W, _W, _W, _W, __};

tm_uchar maze1[]=
     { WW, _W, _W, _W, _W, _W, _W, _W, _W, _W, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, W_, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       W_, __, __, __, __, __, __, __, __, __, W_,
       _W, _W, _W, _W, _W, _W, _W, _W, _W, _W, __};

tm_uchar maze2[]=
     { WW, _W, DW, _W,FWW, WW, _W, _W, _W, _W, _W, _W, W_,
       W_, WW, __, W_, _W, __, W_, _W, _W, _W, _W, W_, W_,
       W_, W_, _W, __,FWW, W_, _W, __,FWW, W_, W_, W_, W_,
       W_, W_, _W, W_, _W, __, W_,FWW, WW, __, W_, __, W_,
       W_, W_, _W, __,FWW, W_, W_, _W, __, WW, _W, W_, W_,
       W_, W_, _W, W_, WW, _D, _W, _W, _W, __, W_, __, W_,
       W_,FWW, W_, W_, D_,FGG, G_, W_, _W, W_, _W, W_, W_,
       W_, _W, __, _W, W_,FGG, G_, WW, __,FWW, W_, W_, W_,
       W_, _W, _W, W_, W_,FGG, G_, W_, W_, _W, _D, __, W_,
       W_, _W, W_, W_, W_,FGG, G_, D_, _W,FWW, WD, W_, W_,
       W_, W_, __, __, W_, _G, __, WW, __, _W, __, W_, W_,
       W_, _W, __, _W, __, WD, _W, __, _W, W_, _W, __, W_,
       _W, _W, _W, _W, _W, _W, _W, _W, _W, _W, _W, _W, __};

tm_uchar maze3[]=
     {F__,F__, WW, _W, WW, _W, WW, _W, _W, W_,
       WW, _W, _W, __, __, W_, __, _W,FWW, __,
       W_,FWW,F_W,F_W,F_W,F_W,F_W, W_,FW_, __,
       W_,FW_,F__, WW, _W,FW_,F__, W_, WW, W_,
       W_, _W, _W, _W, __,FW_,F__, W_, __, W_,
       _W, _W, _W, _W, _W, __, __, _W, _W, __};

CONST MAZE  maze_data[]= {{ "Tills Maze",  11,11, 1,maze0 },
                          { "Falkens Maze",11,11, 1,maze1 },
                          { "MidiMaze",    13,13, 1,maze2 },
                          { "Test-Maze",   10, 6, 1,maze3 },
                          { "",             0, 0, 0,    0 }};
