/*
   mazes.h

   Definitionen fuer Labyrinthe (jaja, Irrgaerten)

   ???       Till  erste Version
   27.11.96  Chip  Typen auf tm_* umgestellt
   08.03.97  Chip  Konstanten hierher
   25.06.97  Chip  Mazedaten zur Manipulation freigegeben
   13.07.97  Chip  PLAYER_DATA erweitert
*/

#ifndef __MAZES__
#define __MAZES__

#include "ctypes.h"

/* maximale Kantenlaenge des */
/* Laby-Wuerfels */
#define MAX_MAZE (16)

/* die moeglichen Objekte */
/* unseres Labyrintes */

#define OB_VISIBLE   (0x1)
#define OB_SOLID     (0x2)
#define OB_MASK      (0x3)

#define OB_FILLED    (0x40)
#define OB_FLAG      (0x80)

#define OB_NOTHING   (0)
#define OB_GLAS      (OB_SOLID)
#define OB_DOOR      (OB_VISIBLE)
#define OB_WALL      (OB_SOLID | OB_VISIBLE)

#define OB_X_SHIFT   (0)
#define OB_Y_SHIFT   (2)
#ifdef MAZE_3D
#define OB_Z_SHIFT   (4)
#endif

typedef struct
{
  tm_char  name[16];
  tm_uword x_size;
  tm_uword y_size;
  tm_uword z_size;       /* vorbereitet fuer 3d */
  tm_uchar *data;
} MAZE;

/* bei der Rotation sind nur die oberen 8 Bits */
/* optisch relevant, die unteren 8 dienen nur  */
/* einer langsameren Drehung                   */
typedef struct
{
  tm_short x;       /* X-Koordinate Vor-/Nachkomma */
  tm_short y;       /* Y   -"- */
#ifdef MAZE_3D
  tm_short z;
  tm_ushort rot_x;
  tm_ushort rot_y;
#endif
  tm_ushort rot_z;	 /* Drehung um die Z-Achse */
  tm_ushort col;

  tm_bool   is_shot;
  tm_word   radius;
} PLAYER_DATA;

extern CONST MAZE maze_data[];

#endif /* __MAZES__ */
