/*
   net_hl.h

   13.09.97  Till  erste Version
*/

#ifndef __NET_HL__
#define __NET_HL__
#include "ctypes.h"
#include "maze.h"
#include "machine.h"

#define MAX_PLAYERS 16

/* type of net */
#define NET_NONE     0
#define NET_IP_UDP   1   /* Internet Datagram Connection */
#define NET_IP_TCP   2   /* Internet Stream Connection   */
#define NET_RS232    3   /* 9600 bit/s serial RS232 */
#define NET_CENTR    4   /* parallel printer port */
#define NET_MIDI     5   /* 31250 bit/s serial MIDI */
#define NET_ALINK    6   /* 20 Mbit/s serial transputer link */
#define NET_IPX      7   /* Novell netware ipx driver */
#define NET_NETBIOS  8   /* Microsoft netbios driver */

#define ENV_ENTRY_NAME "TMUSERNAME"  /* name for environment */

/* div. Konstanten fuer Pakettypen */
#define NET_CHECK   (5)   /* four bit pattern (must not be zero) */

/* Netzstatus */
#define NET_DISC    (0)
#define NET_NOID    (1)   /* Ring geschlossen, aber keine ID erhalten */
#define NET_UP      (2)   /* Verbindung ok */
#define NET_TMASTER (3)
#define NET_MASTER  (4)
#define NET_SLAVE   (5)
#define NET_TSLAVE  (6)

/* Paketbyte 0 (primary type) */
#define DMOVE       (0x00)
#define XMOVE       (0x80)
#define YMOVE       (0x90)
#define PINFO       (0xc0)    /* Timeout-gesichert */
#define SETUP       (0xb0)

/* Byte1 fuer SETUP */
#define SYNC        (0x80)
#define ID          (0x00)
#define ENUM        (0x01)
#define OVERFLOW    (0x02)
#define MASTER_REQ  (0x03)
#define MASTER_ACK  (0x04)
#define RECREATE    (0x05)

/* from net driver */
#ifdef I_KNOW_YOUR_NAME
extern tm_char *get_player_name(tm_char *name, tm_word maxlen);
#endif

extern tm_char net_driver_name[];
extern tm_bool i_am_master;
extern tm_word my_id,players;
extern PLAYER_DATA player[MAX_PLAYERS];
extern tm_bool game_running;

extern tm_void init_net_options(tm_void);
extern tm_void show_net_options(tm_void);
extern tm_bool set_net_option(tm_char *cmd);
#endif /* __NET_HL__ */
