/*
   raw2wall.c

   Waende malen in allen Varianten

   08.03.97   chip   first version
   10.09.97   Till   Multimodekrempel eingebaut

  ACHTUNG! Diese Quelle muss hinter raw2.c "included" werden...
  Weitere Bemerkungen siehe dort!
*/

#include "drawmaze.h"
#include "mazes.h"

#ifndef SCR_XOFFS
#define SCR_XOFFS  (width/2)
#define SCR_YOFFS  (pf_height/2)
#endif

#ifdef WALLS_LINES

#ifndef X_R2_WALL2
#ifdef MULTIMODE
tm_void r2_wall_2(tm_uword x,tm_uword h,
               tm_uword wall_col,tm_uword border_col)
#else
tm_void wall_2(tm_uword x,tm_uword h,
               tm_uword wall_col,tm_uword border_col)
#endif
{
  (tm_void)wall_col;
  draw_vline(x,SCR_YOFFS-h,2*h+1,border_col);
}
#endif

#ifndef X_R2_WALL4
#ifdef MULTIMODE
tm_void r2_wall_4(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword wall_col,tm_uword border_col)
#else
tm_void wall_4(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword wall_col,tm_uword border_col)
#endif
{
  draw_line(x1,SCR_YOFFS-h1,x2,SCR_YOFFS-h2,wall_col);
  draw_line(x1,SCR_YOFFS+h1,x2,SCR_YOFFS+h2,wall_col);
  draw_vline(x1,SCR_YOFFS-h1,2*h1+1,border_col);
  draw_vline(x2,SCR_YOFFS-h2,2*h2+1,border_col);
}
#endif

#ifndef X_R2_WALL6
#ifdef MULTIMODE
tm_void r2_wall_6(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword x3,tm_uword h3,
               tm_uword wall_col,tm_uword border_col)
#else
tm_void wall_6(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword x3,tm_uword h3,
               tm_uword wall_col,tm_uword border_col)
#endif
{
  if (h1>h3)
  {
    draw_hline(x1,SCR_YOFFS-h1,x2-x1+1,wall_col);
    draw_hline(x1,SCR_YOFFS+h1,x2-x1+1,wall_col);
    draw_line(x2,SCR_YOFFS-h2,x3,SCR_YOFFS-h3,wall_col);
    draw_line(x2,SCR_YOFFS+h2,x3,SCR_YOFFS+h3,wall_col);
  }
  else /* h1>h3 */
  {
    draw_line(x1,SCR_YOFFS-h1,x2,SCR_YOFFS-h2,wall_col);
    draw_line(x1,SCR_YOFFS+h1,x2,SCR_YOFFS+h2,wall_col);
    draw_hline(x2,SCR_YOFFS-h3,x3-x2+1,wall_col);
    draw_hline(x2,SCR_YOFFS+h3,x3-x2+1,wall_col);
  }
  draw_vline(x1,SCR_YOFFS-h1,2*h1+1,border_col);
  draw_vline(x3,SCR_YOFFS-h3,2*h3+1,border_col);
}
#endif

#endif /* WALLS_LINES */


#if defined(WALLS_FILLED) | defined(WALLS_SHADED)

#define V_BORDER  /* Waende mit senkrechten Raendern */
#define noH_BORDER  /* Waende mit waagerechten Raendern */

static CONST tm_ulong *pattern;

static tm_void wall_hline(tm_uword x1,tm_uword x2,tm_uword y)
{
/* x1<=x2 */
  tm_ulong  mm;  
  tm_ulong  ml,mr;
  tm_ulong  *p;

  mm=pattern[y&7];

  p=(tm_ulong *)screen_base+y*LWIDTH;  
  ml=r2_l_tab[x1&0x1F];
  mr=r2_r_tab[x2&0x1F];
  x1>>=5;
  x2>>=5;
  p+=x1;
  x2-=x1;
  if (x2==0)
  {
    ml&=mr;
    *p&=~ml;
    *p|=ml&mm;
  }
  else
  {
    *p++=(*p&~ml)|(ml&mm);
    while (--x2)
      *p++=mm;
    *p=(*p&~mr)|(mr&mm);
  }
}

#ifdef MULTIMODE
tm_void r2_wall_2(tm_uword x,tm_uword h,
               tm_uword wall_col,tm_uword border_col)
#else
tm_void wall_2(tm_uword x,tm_uword h,
               tm_uword wall_col,tm_uword border_col)
#endif
{
  (tm_void)wall_col;
  draw_vline(x,SCR_YOFFS-h,2*h+1,border_col);
}

#ifdef MULTIMODE
tm_void r2_wall_4(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword wall_col,tm_uword border_col)
#else
tm_void wall_4(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword wall_col,tm_uword border_col)
#endif
{
/* x1<x2, h1!=0 || h2!=0 */

  tm_uword  i,xx,hh,co1,co2;
  tm_word   e;

  if (x1>=x2 || (h1==0 && h2==0))
    return;

  pattern=r2_h_pattern[wall_col];

#ifdef V_BORDER
  draw_vline(x1,SCR_YOFFS-h1,2*h1+1,border_col);
  draw_vline(x2,SCR_YOFFS-h2,2*h2+1,border_col);
  if (x1==x2-1)
    return;
#endif

  if (h1<h2)
  {
    hh=h2-h1;
    xx=x2-x1;
#ifdef V_BORDER
    x2--;
#endif
    i=h1+h1;
    h1+=SCR_YOFFS;
    h2=h1;

    if (i!=0)
    {
#ifdef V_BORDER
      x1++;
#endif
      while (--i)
        wall_hline(x1,x2,--h2);
#ifdef V_BORDER
      x1--;
#endif
      h2--;
    }

    if (xx>=hh)
    {
      i=xx+1;
      hh+=hh;
      e=(tm_word)hh-(tm_word)xx;
      xx+=xx;
      co1=x1;
      if (hh==0)
        x1=x2;
      do
      {
        if (x1++==x2)
          break;
        if (e>=0)
        {
#ifdef H_BORDER
          draw_hline(co1,h1,x1-co1,border_col);
          draw_hline(co1,h2,x1-co1,border_col);
          wall_hline(x1,x2,h1++);
          wall_hline(x1,x2,h2--);
#else
          wall_hline(co1,x2,h1++);
          wall_hline(co1,x2,h2--);
#endif
          co1=x1;
          e-=xx;
        }
        e+=hh;
      }
      while (--i);
      if (co1!=x1)
      {
#ifdef H_BORDER
        draw_hline(co1,h1,x2-co1+1,border_col);
        draw_hline(co1,h2,x2-co1+1,border_col);
#else
        wall_hline(co1,x2,h1);
        wall_hline(co1,x2,h2);
#endif
      }
    }
    else /* xx>=hh */
    {
      i=hh+1;
      xx+=xx;
      e=(tm_word)xx-(tm_word)hh;
      hh+=hh;
#ifdef H_BORDER
      co1=h1;
      co2=h2;
#endif
      do
      {
#ifdef H_BORDER
        if (x1<x2)
        {
          wall_hline(x1+1,x2,h1);
          wall_hline(x1+1,x2,h2);
        }
        h1++;
        h2--;
#else
        wall_hline(x1,x2,h1++);
        wall_hline(x1,x2,h2--);
#endif
        if (e>=0)
        {
#ifdef H_BORDER
          draw_vline(x1,co1,h1-co1,border_col);
          draw_vline(x1,h2+1,co2-h2,border_col);
          co1=h1;
          co2=h2;
#endif
          if (x1++==x2)
            break;
          e-=hh;
        }
        e+=xx;
      }
      while (--i);
#ifdef H_BORDER
      if (co1!=h1)
      {
        draw_vline(x1,co1,h1-co1,border_col);
        draw_vline(x1,h2+1,co2-h2,border_col);
      }
#endif
    }
  }
  else /* h1<h2 */
  {
    hh=h1-h2;
    xx=x2-x1;
#ifdef V_BORDER
    x1++;
#endif
    i=h2+h2;
    h2+=SCR_YOFFS;
    h1=h2;

    if (i!=0)
    {
#ifdef V_BORDER
      x2--;
#endif
      while (--i)
        wall_hline(x1,x2,--h2);
#ifdef V_BORDER
      x2++;
#endif
      h2--;
    }

    if (xx>=hh)
    {
      i=xx+1;
      hh+=hh;
      e=(tm_word)hh-(tm_word)xx;
      xx+=xx;
      co2=x2;
      if (hh==0)
        x2=x1;
      do
      {
        if (x2--==x1)
          break;
        if (e>=0)
        {
#ifdef H_BORDER
          draw_hline(x2,h1,co2-x2+1,border_col);
          draw_hline(x2,h2,co2-x2+1,border_col);
          wall_hline(x1,x2,h1++);
          wall_hline(x1,x2,h2--);
#else
          wall_hline(x1,co2,h1++);
          wall_hline(x1,co2,h2--);
#endif
          co2=x2;
          e-=xx;
        }
        e+=hh;
      }
      while (--i);
      if (co2!=x2)
      {
#ifdef H_BORDER
        draw_hline(x1,h1,co2-x1+1,border_col);
        draw_hline(x1,h2,co2-x1+1,border_col);
#else
        wall_hline(x1,co2,h1);
        wall_hline(x1,co2,h2);
#endif
      }
    }
    else /* xx>=hh */
    {
      i=hh+1;
      xx+=xx;
      e=(tm_word)xx-(tm_word)hh;
      hh+=hh;
#ifdef H_BORDER
      co1=h1;
      co2=h2;
#endif
      do
      {
#ifdef H_BORDER
        if (x1<x2)
        {
          wall_hline(x1,x2-1,h1);
          wall_hline(x1,x2-1,h2);
        }
        h1++;
        h2--;
#else
        wall_hline(x1,x2,h1++);
        wall_hline(x1,x2,h2--);
#endif
        if (e>=0)
        {
#ifdef H_BORDER
          draw_vline(x2,co1,h1-co1,border_col);
          draw_vline(x2,h2+1,co2-h2,border_col);
          co1=h1;
          co2=h2;
#endif
          if (x2--==x1)
            break;
          e-=hh;
        }
        e+=xx;
      }
      while (--i);
#ifdef H_BORDER
      if (co1!=h1)
      {
        draw_vline(x2,co1,h1-co1,border_col);
        draw_vline(x2,h2+1,co2-h2,border_col);
      }
#endif
    }
  }
}

#ifdef MULTIMODE
tm_void r2_wall_6(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword x3,tm_uword h3,
               tm_uword wall_col,tm_uword border_col)
#else
tm_void wall_6(tm_uword x1,tm_uword h1,
               tm_uword x2,tm_uword h2,
               tm_uword x3,tm_uword h3,
               tm_uword wall_col,tm_uword border_col)
#endif
{
/* x1<x2<x3, h2!=0, h1==h2 || h2==h3 */

  tm_uword  i,xx,hh,co1,co2;
  tm_word   e;

  if (x1>=x2 || x2>=x3 || h2==0)
    return;

  pattern=r2_h_pattern[wall_col];

#ifdef V_BORDER
  draw_vline(x1,SCR_YOFFS-h1,2*h1+1,border_col);
  draw_vline(x3,SCR_YOFFS-h3,2*h3+1,border_col);
#endif

  if (h1>h3)
  {
    hh=h2-h3;
    xx=x3-x2;
#ifdef V_BORDER
    x1++;
#endif
    i=h3+h3;
    h3+=SCR_YOFFS;
    h2=h3;

    if (i!=0)
    {
#ifdef V_BORDER
      x3--;
#endif
      while (--i)
        wall_hline(x1,x3,--h2);
#ifdef V_BORDER
      x3++;
#endif
      h2--;
    }

    if (xx>=hh)
    {
      i=xx+1;
      hh+=hh;
      e=(tm_word)hh-(tm_word)xx;
      xx+=xx;
      co2=x3;
      if (hh==0)
        x3=x2;
      while (--i)
      {
        if (x3--==x2)
          break;
        if (e>=0)
        {
#ifdef H_BORDER
          draw_hline(x3+1,h2,co2-x3,border_col);
          draw_hline(x3+1,h3,co2-x3,border_col);
          wall_hline(x1,x3,h2--);
          wall_hline(x1,x3,h3++);
#else
          wall_hline(x1,co2,h2--);
          wall_hline(x1,co2,h3++);
#endif
          co2=x3;
          e-=xx;
        }
        e+=hh;
      }
#ifdef H_BORDER
      draw_hline(x1,h2,co2-x1+1,border_col);
      draw_hline(x1,h3,co2-x1+1,border_col);
#else
      wall_hline(x1,co2,h2);
      wall_hline(x1,co2,h3);
#endif
    }
    else /* xx>=hh */
    {
      i=hh+1;
      xx+=xx;
      e=(tm_word)xx-(tm_word)hh;
      hh+=hh;
#ifdef H_BORDER
      co1=h2;
      co2=h3;
#endif
      while (--i)
      {
#ifdef H_BORDER
        wall_hline(x1,x3-1,h2--);
        wall_hline(x1,x3-1,h3++);
#else
        wall_hline(x1,x3,h2--);
        wall_hline(x1,x3,h3++);
#endif
        if (e>=0)
        {
#ifdef H_BORDER
          draw_vline(x3,h2+1,co1-h2,border_col);
          draw_vline(x3,co2,h3-co2,border_col);
          co1=h2;
          co2=h3;
#endif
          if (x3--==x2)
            break;
          e-=hh;
        }
        e+=xx;
      }
#ifdef H_BORDER
      if (co1!=h2)
      {
        draw_vline(x3,h2+1,co1-h2,border_col);
        draw_vline(x3,co2,h3-co2,border_col);
      }
      draw_hline(x1,h2,x3-x1+1,border_col);
      draw_hline(x1,h3,x3-x1+1,border_col);
#else
      wall_hline(x1,x3,h2);
      wall_hline(x1,x3,h3);
#endif
    }
  }
  else /* h1>h3 */
  {
    hh=h2-h1;
    xx=x2-x1;
#ifdef V_BORDER
    x3--;
#endif
    i=h1+h1;
    h1+=SCR_YOFFS;
    h2=h1;

    if (i!=0)
    {
#ifdef V_BORDER
      x1++;
#endif
      while (--i)
        wall_hline(x1,x3,--h2);
#ifdef V_BORDER
      x1--;
#endif
      h2--;
    }

    if (xx>=hh)
    {
      i=xx+1;
      hh+=hh;
      e=(tm_word)hh-(tm_word)xx;
      xx+=xx;
      co1=x1;
      if (hh==0)
        x1=x2;
      while (--i)
      {
        if (x1++==x2)
          break;
        if (e>=0)
        {
#ifdef H_BORDER
          draw_hline(co1,h1,x1-co1,border_col);
          draw_hline(co1,h2,x1-co1,border_col);
          wall_hline(x1,x3,h1++);
          wall_hline(x1,x3,h2--);
#else
          wall_hline(co1,x3,h1++);
          wall_hline(co1,x3,h2--);
#endif
          co1=x1;
          e-=xx;
        }
        e+=hh;
      }
#ifdef H_BORDER
      draw_hline(co1,h1,x3-co1+1,border_col);
      draw_hline(co1,h2,x3-co1+1,border_col);
#else
      wall_hline(co1,x3,h1);
      wall_hline(co1,x3,h2);
#endif
    }
    else /* xx>=hh */
    {
      i=hh+1;
      xx+=xx;
      e=(tm_word)xx-(tm_word)hh;
      hh+=hh;
#ifdef H_BORDER
      co1=h1;
      co2=h2;
#endif
      while (--i)
      {
#ifdef H_BORDER
        wall_hline(x1+1,x3,h1++);
        wall_hline(x1+1,x3,h2--);
#else
        wall_hline(x1,x3,h1++);
        wall_hline(x1,x3,h2--);
#endif
        if (e>=0)
        {
#ifdef H_BORDER
          draw_vline(x1,co1,h1-co1,border_col);
          draw_vline(x1,h2+1,co2-h2,border_col);
          co1=h1;
          co2=h2;
#endif
          if (x1++==x2)
            break;
          e-=hh;
        }
        e+=xx;
      }
#ifdef H_BORDER
      if (co1!=h1)
      {
        draw_vline(x1,co1,h1-co1,border_col);
        draw_vline(x1,h2+1,co2-h2,border_col);
      }
      draw_hline(x1,h1,x3-x1+1,border_col);
      draw_hline(x1,h2,x3-x1+1,border_col);
#else
      wall_hline(x1,x3,h1);
      wall_hline(x1,x3,h2);
#endif
    }
  }
}

#endif /* WALLS_FILLED */

#ifdef TEXTURE
#ifndef X_R2_WALL_4TEX
#ifdef MULTIMODE
tm_void r2_wall_4tex(tm_word xl, tm_word hl,
		       tm_word xr, tm_word hr,
		       tm_uword wall,
		       tm_word xa, tm_word za, tm_word xb, tm_word zb)
#else
tm_void r2_wall_4tex(tm_word xl, tm_word hl,
		       tm_word xr, tm_word hr,
		       tm_uword wall,
		       tm_word xa, tm_word za, tm_word xb, tm_word zb)
#endif
{
}
#endif  /* X_R2_WALL_4TEX */
#endif  /* TEXTURE */

#if 0  /* wird mit WALLS_FILLED erledigt, weils die schon fuer */
       /* 256 Farben gibt und die dann auch benutzt werden sollen */
#ifdef WALLS_SHADED
#error Not yet implemented WALLS_SHADED in raw2wall.c!
#endif /* WALLS_SHADED */
#endif


