/*

  GEM.C

  GEM-Anbindung fuer mksmile

  26.11.96  Chip  Uebernommen von makefont, Farben erweitert
*/

#include <aes.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tos.h>
#include <vdi.h>

#ifdef WHITE
#undef WHITE
#endif
#ifdef BLACK
#undef BLACK
#endif
#ifdef RED
#undef RED
#endif
#ifdef GREEN
#undef GREEN
#endif
#ifdef BLUE
#undef BLUE
#endif
#ifdef YELLOW
#undef YELLOW
#endif
#ifdef MAGENTA
#undef MAGENTA
#endif
#ifdef CYAN
#undef CYAN
#endif
#include "gem.h"

typedef unsigned int uint;

int col_tab[][3]={{1000,1000,1000},{0,0,0},
  {1000,0,0},{0,1000,0},{0,0,1000},
  {0,1000,1000},{1000,1000,0},{1000,0,1000}};
#define COLORS (sizeof(col_tab)/sizeof(int)/3)
int col_old[COLORS][3];

static
uint  *bitmaps[COLORS];
static
int   bm_width,bm_height,linelen,bm_xoffs,bm_yoffs;

static
int  vdi_handle,work_in[11],work_out[57],chrw,chrh;

void init_gem(void) 
{
  int  i,dummy;

  Bconout(2,0x1B);
  Bconout(2,'H');
  Bconout(2,0x1B);
  Bconout(2,'v');

  if (appl_init()<0)
  {
    puts("Kann Applikation nicht anmelden!");
    exit(10);
  }

  vdi_handle=graf_handle(&chrw,&chrh,&dummy,&dummy);
  for (i=0; i<10; i++)
    work_in[i]=1;
  work_in[7]=0;
  work_in[10]=2;
  v_opnvwk(work_in,&vdi_handle,work_out);
  graf_mouse(BUSYBEE,NULL);
  wind_update(BEG_UPDATE);
  for (i=0; i<COLORS; i++)
    vq_color(vdi_handle,i,1,col_old[i]);
  for (i=0; i<COLORS; i++)
    vs_color(vdi_handle,i,col_tab[i]);
}

void exit_gem(void) 
{
  int  i;

  for (i=0; i<COLORS; i++)
    vs_color(vdi_handle,i,col_old[i]);
  wind_update(END_UPDATE);
  v_clsvwk(vdi_handle);
  appl_exit();
}

static char ted1_text[36]="";
static TEDINFO ted1=
{
ted1_text,
"___________________________________",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
3,6,0,0x1180,0x0,-1,36,36,
};

static char ted2_text[36]="";
static TEDINFO ted2=
{
ted2_text,
"___________________________________",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
3,6,0,0x1180,0x0,-1,36,36
};

#include "mksmile.icn"
#if (icon_bitmap_width%16)>=1 && (icon_bitmap_width%16)<=8
#error "bitmap must fit in 16-bit words!"
#endif
#define BITMAP_SIZE ((int)sizeof(icon_bitmap_bits))
static BITBLK bitmap={(int *)icon_bitmap_bits,
  BITMAP_SIZE/icon_bitmap_height,icon_bitmap_height,0,0,1
};

static OBJECT obj[]=
{
-1,1,8,G_BOX,NONE,OUTLINED,0x21100L,0,0,39,11,
2,-1,-1,G_STRING,NONE,NORMAL,(long)"Parameter:",2,1,10,1,
3,-1,-1,G_IMAGE,NONE,NORMAL,(long)&bitmap,37,1,1,1,
4,-1,-1,G_STRING,NONE,NORMAL,(long)"Optional Radius:",2,3,16,1,
5,-1,-1,G_FTEXT,EDITABLE,NORMAL,(long)&ted1,2,4,35,1,
6,-1,-1,G_STRING,NONE,NORMAL,(long)"Dann auch Smileys pro Umdrehung:",2,6,32,1,
7,-1,-1,G_FTEXT,EDITABLE,NORMAL,(long)&ted2,2,7,35,1,
8,-1,-1,G_BUTTON,SELECTABLE|EXIT,NORMAL,(long)"Abbruch",2,9,8,1,
0,-1,-1,G_BUTTON,SELECTABLE|DEFAULT|EXIT|LASTOB,NORMAL,(long)"  OK  ",29,9,8,1
};

int get_parameter(char *argv1,char *argv2)
{
  int  i,new,dh;
  int  fx,fy,fw,fh;

  for (i=0; i<BITMAP_SIZE; i++)
  {
    new = (icon_bitmap_bits[i]&0x01) ? 0x80 : 0;
    new|= (icon_bitmap_bits[i]&0x02) ? 0x40 : 0;
    new|= (icon_bitmap_bits[i]&0x04) ? 0x20 : 0;
    new|= (icon_bitmap_bits[i]&0x08) ? 0x10 : 0;
    new|= (icon_bitmap_bits[i]&0x10) ? 0x08 : 0;
    new|= (icon_bitmap_bits[i]&0x20) ? 0x04 : 0;
    new|= (icon_bitmap_bits[i]&0x40) ? 0x02 : 0;
    new|= (icon_bitmap_bits[i]&0x80) ? 0x01 : 0;
    icon_bitmap_bits[i]=new;
  }

  for (i=0; i<9; i++)
    rsrc_obfix(obj,i);
  form_center(obj,&fx,&fy,&fw,&fh);
  if ((dh=icon_bitmap_height-2*chrh)>0)
  {
    fy-=dh/2;
    fh+=dh;
    obj[0].ob_y-=dh/2;
    obj[0].ob_height+=dh;
    for (i=3; i<9; i++)
      obj[i].ob_y+=dh;
  }
  obj[2].ob_x-=icon_bitmap_width;
  obj[2].ob_width=icon_bitmap_width;
  obj[2].ob_height=icon_bitmap_height;

  graf_mouse(ARROW,NULL);
  form_dial(FMD_START,0,0,0,0,fx,fy,fw,fh);
  objc_draw(obj,0,2,fx,fy,fw,fh);
  i=form_do(obj,4);
  form_dial(FMD_FINISH,0,0,0,0,fx,fy,fw,fh);
  graf_mouse(BUSYBEE,NULL);

  strcpy(argv1,ted1.te_ptext);
  strcpy(argv2,ted2.te_ptext);
  if (i!=8)
    return(0);
  if (strlen(argv1)==0 || strlen(argv2)==0)
    return(1);
  return(3);
}

#define WIN_KIND  (NAME|CLOSER|FULLER|MOVER|SIZER|    \
                   UPARROW|DNARROW|VSLIDE|            \
                   LFARROW|RTARROW|HSLIDE)

static
int win_handle,win_fullw,win_fullh;

int open_window(int argc,char **argv,int width,int height,char *titel)
{
  int     wx,wy,ww,wh,i;
  size_t  size;

  (void)argc;
  (void)argv;

  bm_width=width;
  bm_height=height;
  linelen=(width+15)/16;
  bm_xoffs=0;
  bm_yoffs=0;
  size=sizeof(uint)*linelen*height;

  graf_mouse(M_OFF,NULL);
  wind_get(0,WF_WORKXYWH,&wx,&wy,&ww,&wh);
  wind_calc(WC_WORK,WIN_KIND,wx,wy,ww,wh,&wx,&wy,&ww,&wh);
  if (ww>width)
  {
    wx+=(ww-width)/2;
    ww=width;
  }
  if (wh>height)
  {
    wy+=(wh-height)/2;
    wh=height;
  }
  wind_calc(WC_BORDER,WIN_KIND,wx,wy,ww,wh,&wx,&wy,&ww,&wh);
  win_fullw=ww;
  win_fullh=wh;
  win_handle=wind_create(WIN_KIND,wx,wy,ww,wh);
  wind_set(win_handle,WF_NAME,titel,0,0);
  wind_set(win_handle,WF_VSLSIZE,1000,0,0,0);
  wind_set(win_handle,WF_HSLSIZE,1000,0,0,0);
  wind_set(win_handle,WF_VSLIDE,0,0,0,0);
  wind_set(win_handle,WF_HSLIDE,0,0,0,0);
  wind_open(win_handle,wx,wy,ww,wh);
  graf_mouse(M_ON,NULL);

  for (i=0; i<COLORS; i++)
    bitmaps[i]=NULL;
  for (i=1; i<COLORS; i++)
  {
    bitmaps[i]=(uint *)malloc(size);
    if (bitmaps[i]==NULL)
    {
      close_window();
      exit_gem();
      puts("Speicher voll!");
      exit(11);
    }
    memset(bitmaps[i],0,size);
  }

  draw_bitmap();
  return(1);
}

void close_window(void)
{
  int  i;

  graf_mouse(M_OFF,NULL);
  wind_close(win_handle);
  wind_delete(win_handle);
  graf_mouse(M_ON,NULL);

  for (i=1; i<COLORS; i++)
    if (bitmaps[i]!=NULL)
      free(bitmaps[i]);
}

void put_pixel(int x, int y, unsigned char color)
{
  long          offset;
  unsigned int  mask,i;

  if (color==0 || color>=COLORS)
    return;

  mask = 0x8000>>(x&0xF);
  offset=(long)y*linelen + (x>>4);

  for (i=1; i<COLORS; i++)
    bitmaps[i][offset] &= ~mask;
  bitmaps[color][offset] |= mask;
}


static
int rc_intersect(int cx,int cy,int cw,int ch,
                 int *rx,int *ry,int *rw,int *rh)
{
int  ix0,iy0,ix1,iy1;

ix0=*rx>cx ? *rx : cx;
ix1=(*rx+*rw)<(cx+cw) ? *rx+*rw : cx+cw;
iy0=*ry>cy ? *ry : cy;
iy1=(*ry+*rh)<(cy+ch) ? *ry+*rh : cy+ch;
if (ix1>ix0 && iy1>iy0) {
  *rx=ix0;
  *ry=iy0;
  *rw=ix1-ix0;
  *rh=iy1-iy0;
  return(1);
} else
  return(0);
}

static
void set_decoration(void)
{
  int   ww,wh,val;

  wind_get(win_handle,WF_WORKXYWH,&val,&val,&ww,&wh);
  if (bm_xoffs<0)
    bm_xoffs=0;
  else if (bm_xoffs>bm_width-ww)
    bm_xoffs=bm_width-ww;
  if (bm_yoffs<0)
    bm_yoffs=0;
  else if (bm_yoffs>bm_height-wh)
    bm_yoffs=bm_height-wh;

  val=(int)((1000L*ww)/bm_width);
  wind_set(win_handle,WF_HSLSIZE,val,0,0,0);
  val=(int)((1000L*wh)/bm_height);
  wind_set(win_handle,WF_VSLSIZE,val,0,0,0);
  if (bm_width-ww==0)
    val=1000;
  else if (bm_xoffs<=(bm_width-ww))
    val=(int)((1000L*bm_xoffs)/(bm_width-ww));
  else
    val=0;
  wind_set(win_handle,WF_HSLIDE,val,0,0,0);
  if (bm_height-wh==0)
    val=1000;
  else if (bm_yoffs<=(bm_height-wh))
    val=(int)((1000L*bm_yoffs)/(bm_height-wh));
  else
    val=0;
  wind_set(win_handle,WF_VSLIDE,val,0,0,0);
}

void draw_bitmap(void) 
{
  int   x,y,w,h,wx,wy,ww,wh;
  int   i,col[2],pxy[8];
  MFDB  srce,dest;

  set_decoration();

  wind_get(win_handle,WF_WORKXYWH,&x,&y,&w,&h);

  col[1]=0;

  dest.fd_addr=NULL;

  srce.fd_w=bm_width;
  srce.fd_h=bm_height;
  srce.fd_wdwidth=linelen;
  srce.fd_stand=1;
  srce.fd_nplanes=1;

  graf_mouse(M_OFF,NULL);

  wind_get(win_handle,WF_FIRSTXYWH,&wx,&wy,&ww,&wh);
  while (ww!=0 && wh!=0)
  {
    if (rc_intersect(x,y,w,h,&wx,&wy,&ww,&wh))
    {
      pxy[4]=wx;
      pxy[5]=wy;
      pxy[6]=wx+ww-1;
      pxy[7]=wy+wh-1;
      pxy[0]=pxy[4]-x+bm_xoffs;
      pxy[1]=pxy[5]-y+bm_yoffs;
      pxy[2]=pxy[6]-x+bm_xoffs;
      pxy[3]=pxy[7]-y+bm_yoffs;
      srce.fd_addr=bitmaps[1];
      col[0]=1;
      vrt_cpyfm(vdi_handle,MD_REPLACE,pxy,&srce,&dest,col);
      for (i=2; i<COLORS; i++)
      {
        srce.fd_addr=bitmaps[i];
        col[0]=i%work_out[13];
        vrt_cpyfm(vdi_handle,MD_TRANS,pxy,&srce,&dest,col);
      }
    }
    wind_get(win_handle,WF_NEXTXYWH,&wx,&wy,&ww,&wh);
  }
  graf_mouse(M_ON,NULL);
}

int get_key(void)
{
  static int first=1;
  int  event,message[8],dummy,kchar;
  int  wx,wy,ww,wh;

  if (first)
  {
    graf_mouse(ARROW,NULL);
    first=0;
  }
  graf_mouse(ARROW,NULL);
  wind_update(END_UPDATE);
  event=evnt_multi(MU_MESAG|MU_KEYBD|MU_TIMER,
                   0,0,0,                 /* keine Maus */
                   0,0,0,0,0,             /* kein Bereich 1 */
                   0,0,0,0,0,             /* kein Bereich 2 */
                   message,               /* Meldungen */
                   100,0,                 /* kein Timer */
                   &dummy,&dummy,&dummy,  /* keine Maus */
                   &dummy,&kchar,         /* Tasten */
                   &dummy);               /* keine Maus */
  wind_update(BEG_UPDATE);
  graf_mouse(BUSYBEE,NULL);
  if ((event&MU_MESAG) && message[3]==win_handle)
    switch (message[0])
    {
    case WM_CLOSED:
      return(1);
    case WM_REDRAW:
      draw_bitmap();
      break;
    case WM_TOPPED:
    case WM_NEWTOP:
      wind_set(win_handle,WF_TOP,0,0,0,0);
      break;
    case WM_FULLED:
      wind_get(win_handle,WF_CURRXYWH,&wx,&wy,&ww,&wh);
      if (ww<win_fullw || wh<win_fullh)
      {
        ww=win_fullw;
        wh=win_fullh;
      }
      else
        wind_get(win_handle,WF_PREVXYWH,&wx,&wy,&ww,&wh);
      wind_set(win_handle,WF_CURRXYWH,wx,wy,ww,wh);
      set_decoration();
      break;
    case WM_ARROWED:
      wind_get(win_handle,WF_WORKXYWH,&wx,&wy,&ww,&wh);
      switch (message[4])
      {
        case WA_UPPAGE:
          bm_yoffs-=wh;
          break;
        case WA_DNPAGE:
          bm_yoffs+=wh;
          break;
        case WA_UPLINE:
          bm_yoffs-=chrh;
          break;
        case WA_DNLINE:
          bm_yoffs+=chrh;
          break;
        case WA_LFPAGE:
          bm_xoffs-=ww;
          break;
        case WA_RTPAGE:
          bm_xoffs+=ww;
          break;
        case WA_LFLINE:
          bm_xoffs-=chrw;
          break;
        case WA_RTLINE:
          bm_xoffs+=chrw;
          break;
      }
      draw_bitmap();
      break;
    case WM_HSLID:
      wind_get(win_handle,WF_WORKXYWH,&wx,&wy,&ww,&wh);
      bm_xoffs=(int)(((long)message[4]*(bm_width-ww))/1000L);
      draw_bitmap();
      break;
    case WM_VSLID:
      wind_get(win_handle,WF_WORKXYWH,&wx,&wy,&ww,&wh);
      bm_yoffs=(int)(((long)message[4]*(bm_height-wh))/1000L);
      draw_bitmap();
      break;
    case WM_SIZED:
      wind_get(win_handle,WF_CURRXYWH,&wx,&wy,&ww,&wh);
      if (message[6]>win_fullw)
        message[6]=win_fullw;
      if (message[7]>win_fullh)
        message[7]=win_fullh;
      wind_set(win_handle,WF_CURRXYWH,wx,wy,message[6],message[7]);
      set_decoration();
      break;
    case WM_MOVED:
      wind_get(win_handle,WF_CURRXYWH,&wx,&wx,&ww,&wh);
      wind_set(win_handle,WF_CURRXYWH,message[4],message[5],ww,wh);
      break;
    }
  if (event&MU_KEYBD)
    return(1);
  return(0);
}
