/*
   TEXT.C
   
   Alle Texte von MAZE,

   Die Texte halten sich an die LaTeX-Notation fuer
   Sonderzeichen, (\"A ist der grosse deutsche A-Umlaut,
   in C schreibt sich das dann \\\"A ), aber es sind bisher
   nicht alle implementiert...

   ???       Till  erste Texte, Erweiterungen
   ???       Chip  Erweiterungen
   28.11.96  Chip  Typen auf tm_* umgestellt
   26.01.97  Chip  Texteingabe
   23.08.97  Till  Fileselektor
*/

#include "ctypes.h"
#include "text.h"
#include "audio.h"
#include "machine.h"
#ifdef MACHINE_HAS_FILESYSTEM
#include <stdio.h>
#endif

tm_char *language_msg[]={"Deutsch","English"};
tm_char *error_msg[]={"FEHLER","ERROR"};

tm_char *machine_name[]={"IBM-PC/DOS",
                         "Atari ST/TOS",
                         "Tills Diplo",
                         "Unix/XWindow"};

tm_char *no_video_buffer[]={"FEHLER: Videopuffer kann nicht alloziert werden!",
                            "ERROR: Unable to allocate video buffer!"};

#ifdef MACHINE_PC_DOS
/* PC-spezifische Texte */
tm_char *no_vga[]={"FEHLER: Keine VGA-Karte installiert!",
                   "ERROR: No vga card installed!"};
tm_char *no_mouse[]={"Kein  Maustreiber|installiert!",
                     "No mouse driver|installed!"};
tm_char *no_joy[]={"Kein  Joystick|installiert!",
                     "No joystick|installed!"};
#endif

#ifdef MACHINE_ATARI_ST
/* ST-spezifische Texte */
tm_char *no_appl_init[]={"Kann Applikation|nicht anmelden",
                         "Can't initialize|application"};
tm_char *wrong_display[]={"Falscher Bildschirm","Wrong display"};
#endif

/* Texte fuer analoge Joysticks */
tm_char *joystick_kalibration[]={"Joystick-Kalibrierung","Joystick calibration"};
tm_char *joystick_kal1[]={"Bitte bewegen Sie den|Joystick nach links oben und|dr\\\"ucken Sie dann Feuer.",
                          "Please move joystick to the|upper left corner and|press the fire button."};
tm_char *joystick_kal2[]={"Bitte bewegen Sie den|Joystick nach rechts unten und|dr\\\"ucken Sie dann Feuer.",
                          "Please move joystick to the|lower right corner and|press the fire button."};
tm_char *joystick_kal3[]={"Bitte bewegen Sie den|Joystick in die Mitte und|dr\\\"ucken Sie dann Feuer.",
                          "Please center joystick and|press the fire button."};

tm_char *dialog_program_title[]={"Programminfo","Program Info"};
tm_char *dialog_program_msg[]={"Maschinentyp:&%s|Videotreiber:&%s|Eingabetreiber:&%s|"
			       "Timertreiber:&%s|Soundtreiber:&%s|Netztreiber:&%s"
#ifdef ARCH
			       "|Architektur:&" ARCH
#endif
                               ,"machine type:&%s|video driver:&%s|input driver:&%s|"
			       "timer driver:&%s|sound driver:&%s|net driver:&%s"
#ifdef ARCH
			       "|architecture:&" ARCH
#endif
};

extern tm_void dialog_program_info(tm_void);

tm_char *dialog_system_title[]={"Systeminfo","System Info"};
tm_char *dialog_system_msg[]={"Millisekunden pro Bild:&%lu.%02lu|"
			      "Millisekunden pro FlipScreen:&%lu.%02lu|"
			      "Bilder pro Sekunde:&%lu.%02lu",
                              "Milliseconds per Frame:&%lu.%02lu|"
			      "Milliseconds per FlipScreen:&%lu.%02lu|"
			      "Frames per Second:&%lu.%02lu"};
extern tm_void dialog_system_info(tm_void);

tm_char *dialog_general_title[]={"TheMaze, erdacht von Till und Chip",
                                 "TheMaze, devised by Till and Chip"};
tm_char *dialog_general_msg[]={"Dies ist nur eine Beta-Version, die|"
                               "der GNU-Lizenz unterliegt. Weitergabe|"
                               "bitte nur mit dem kompletten Archiv.|"
                               "\\\"Anderungen und Erweiterungsvorschl\\\"age|"
                               "nehmen wir gerne entgegen und ggf. auf!",
                               "This is only a beta version that|"
                               "is under the GNU license. Please|"
                               "copy the whole archive. Any|"
                               "ideas and changes are welcome!"};
extern tm_void dialog_general_info(tm_void);

#ifdef MACHINE_HAS_FILESYSTEM
tm_void test_filesel(tm_char *file) {
  printf("loading file '%s'\n",file);
}
#endif

MENU_ENTRY  menu[][7]=      /* maximal 7 Eintraege pro Menu */
{
   /* Menu 0 */
 { {"The Maze"       ,"The Maze"       ,MENU_TOP     ,NULL_PTR },
   {"Spieloptionen"  ,"Game Options"   ,MENU_SUB     ,(tm_void*)1 },
   {"Information"    ,"Information"    ,MENU_SUB     ,(tm_void*)3 },
   {"Spiel beenden"  ,"Exit Game"      ,MENU_QUIT    ,NULL_PTR },
   {"Weiterspielen"  ,"Continue Game"  ,MENU_END     ,(tm_void*)MENU_TOP } },

   /* Menu 1 */
 { {"Spieloptionen"  ,"Game Options"   ,MENU_TITLE   ,NULL_PTR },
#ifdef AUDIO_AVAILABLE
   {"Audio"          ,"Audio"          ,MENU_SUB     ,(tm_void*)2 },
#endif
   {"Extras"         ,"Extras"         ,MENU_NOTHING ,NULL_PTR },
   {"Karte"          ,"Map"            ,MENU_NOTHING ,NULL_PTR },
#ifdef MACHINE_HAS_FILESYSTEM
   {"Maze laden"     ,"Load Maze"      ,MENU_FILESEL ,(tm_void*)test_filesel },
#endif
   {"Name: "         ,"Name: "         ,MENU_STRING  ,player_name },
   {"Zur\\\"uck"     ,"Back"           ,MENU_END     ,(tm_void*)0 } },

   /* Menu 2 */
 { {"Audio"          ,"Audio"          ,MENU_TITLE   ,NULL_PTR },
#ifdef AUDIO_AVAILABLE
   {"Musik Ein"      ,"Music On"       ,MENU_CHECK   ,audio_on },
#ifdef AUDIO_VOLUME
   {"Lautst\\\"arke" ,"Volume"         ,MENU_SCALE   ,vol_audio },
#endif
#ifdef AUDIO_BALANCE
   {"Balance"        ,"Balance"        ,MENU_SCALE   ,bal_audio },
#endif
   {"Audio-Test"     ,"Test Audio"     ,MENU_EXEC    ,test_audio },
#endif
   {"Zur\\\"uck"     ,"Back"           ,MENU_END     ,(tm_void*)1 } },

   /* Menu 3 */
 { {"Information"    ,"Information"    ,MENU_TITLE   ,NULL_PTR },
   {"Allgemeine Info","General Info"   ,MENU_EXEC    ,dialog_general_info },
   {"Programminfo"   ,"Program Info"   ,MENU_EXEC    ,dialog_program_info },
   {"Systeminfo"     ,"System Info"    ,MENU_EXEC    ,dialog_system_info },
   {"Zur\\\"uck"     ,"Back"           ,MENU_END     ,(tm_void*)0 } }
};

tm_char *get_string_delete[]={"Entf.","Delete"};
tm_char *get_string_shift[] ={"Umsch.","Shift"};
tm_char *get_string_ok[]    ={"OK","OK"};

tm_char *fileselect_cancel[]={"Abbruch","Cancel"};
