#include <aes.h>
#include <ext.h>
#include <stdio.h>
#include <tos.h>
#include <vdi.h>

static	int	vdi_handle;	/* fuer GEM, ganz primitiv */
typedef unsigned char tm_ubyte;

#define _HZ_200 (*((long *)0x4BAL))

long hz_200(void) { return(_HZ_200); }

void measure(void) {
long t,m;
for (m=0, t=Supexec(hz_200)+200; t>Supexec(hz_200); m++);
printf("Zhler = %ld\n",m);
}

/*----------------------------------------------------------------*/

static int divider[]={
/* 45 = a = 440 Hz = 0x11c */
0xEEE,0xE18,0xD4D,0xC8E,0xBDA,0xB2F,0xA8F,0x9F7,0x968,0x8E1,0x861,0x7E9,
0x777,0x70C,0x6A7,0x647,0x5ED,0x598,0x547,0x4FC,0x4B4,0x470,0x431,0x3F4,
0x3BC,0x386,0x353,0x324,0x2F6,0x2CC,0x2A4,0x27E,0x25A,0x238,0x218,0x1FA,
0x1DE,0x1C3,0x1AA,0x192,0x17B,0x166,0x152,0x13F,0x12D,0x11C,0x10C,0x0FD,
0x0EF,0x0E1,0x0D5,0x0C9,0x0BE,0x0B3,0x0A9,0x09F,0x096,0x08E,0x086,0x07F,
0};

enum { PAUSE=sizeof(divider)/sizeof(int),
       ADSR,ARPEGGIO,VIBRATO,LENGTH,LOOP,STOP,END};

#define SPEED 2

static tm_ubyte _tab0[]={0,3,6, 9,12,3,15,18,21,18,24,18,27,END,0};
static tm_ubyte _tab1[]={1,4,7,10,13,4,16,19,22,19,25,19,28,END,0};
static tm_ubyte _tab2[]={2,5,8,11,14,5,17,20,23,20,26,20,29,END,0};
static tm_ubyte *tab_tab[]={_tab0,_tab1,_tab2};

static tm_ubyte _seq0[]={
ADSR,0,
ARPEGGIO,0,
VIBRATO,0,
LENGTH,6*SPEED,
44,
LENGTH,1*SPEED,
42,
44,
LENGTH,4*SPEED,
45,
ADSR,3,
28,
PAUSE,
28,
PAUSE,
28,
28,
ADSR,2,
LENGTH,2*SPEED,
40,
PAUSE,
END};

static tm_ubyte _seq1[]={
ADSR,0,
ARPEGGIO,1,
VIBRATO,1,
LENGTH,8*SPEED,
23,
LENGTH,4*SPEED,
21,
ADSR,3,
21,
PAUSE,
21,
PAUSE,
21,
21,
21,
END};

static tm_ubyte _seq2[]={
ADSR,4,
ARPEGGIO,2,
VIBRATO,2,
LENGTH,8*SPEED,
4,
ADSR,3,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
END};

static tm_ubyte _seq3[]={
LENGTH,1*SPEED,
40,
LENGTH,3*SPEED,
52,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
40,
PAUSE,
LENGTH,1*SPEED,
40,
LENGTH,3*SPEED,
52,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
52,
PAUSE,
52,
PAUSE,
52,
PAUSE,
52,
PAUSE,
52,
PAUSE,
LENGTH,4*SPEED,
52,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
42,
PAUSE,
LENGTH,1*SPEED,
44,
LENGTH,3*SPEED,
47,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
42,
PAUSE,
LENGTH,1*SPEED,
44,
LENGTH,3*SPEED,
47,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
32,
33,
ADSR,1,
35,
37,
38,
40,
ADSR,0,
42,
44,
45,
47,
LENGTH,4*SPEED,
49,
LENGTH,8*SPEED,
PAUSE,
ADSR,2,
LENGTH,2*SPEED,
40,
PAUSE,
LENGTH,1*SPEED,
40,
LENGTH,3*SPEED,
52,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
40,
PAUSE,
END};

static tm_ubyte _seq4[]={
ADSR,3,
LENGTH,4*SPEED,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
21,
ADSR,2,
LENGTH,2*SPEED,
51,
PAUSE,
50,
PAUSE,
49,
PAUSE,
47,
PAUSE,
45,
PAUSE,
LENGTH,4*SPEED,
44,
ADSR,3,
20,
20,
20,
PAUSE,
20,
PAUSE,
20,
PAUSE,
20,
20,
ADSR,2,
LENGTH,2*SPEED,
28,
30,
ADSR,1,
32,
33,
35,
37,
ADSR,0,
38,
40,
42,
44,
LENGTH,4*SPEED,
45,
ADSR,3,
21,
21,
21,
PAUSE,
21,
PAUSE,
21,
END};

static tm_ubyte _seq5[]={
ADSR,3,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
9,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
4,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
4,
PAUSE,
4,
PAUSE,
4,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
4,
PAUSE,
4,
PAUSE,
9,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
END};

static tm_ubyte _seq6[]={
LENGTH,1*SPEED,
40,
LENGTH,3*SPEED,
52,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
52,
PAUSE,
52,
PAUSE,
52,
PAUSE,
52,
PAUSE,
52,
PAUSE,
52,
LENGTH,10*SPEED,
PAUSE,
LENGTH,2*SPEED,
44,
PAUSE,
LENGTH,1*SPEED,
44,
LENGTH,3*SPEED,
49,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
44,
PAUSE,
LENGTH,1*SPEED,
44,
LENGTH,3*SPEED,
49,
LENGTH,8*SPEED,
PAUSE,
ADSR,1,
LENGTH,2*SPEED,
30,
32,
34,
PAUSE,
37,
PAUSE,
40,
PAUSE,
46,
PAUSE,
LENGTH,12*SPEED,
47,
ADSR,0,
LENGTH,4*SPEED,
47,
END};

static tm_ubyte _seq7[]={
LENGTH,4*SPEED,
PAUSE,
21,
21,
ADSR,2,
LENGTH,2*SPEED,
51,
PAUSE,
50,
PAUSE,
49,
PAUSE,
47,
PAUSE,
45,
PAUSE,
44,
PAUSE,
ADSR,3,
LENGTH,4*SPEED,
20,
20,
20,
PAUSE,
25,
25,
LENGTH,8*SPEED,
PAUSE,
LENGTH,4*SPEED,
25,
25,
LENGTH,8*SPEED,
PAUSE,
ADSR,1,
LENGTH,4*SPEED,
21,
PAUSE,
21,
PAUSE,
23,
23,
PAUSE,
END};

static tm_ubyte _seq8[]={
LENGTH,4*SPEED,
9,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
11,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
10,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
10,
LENGTH,12*SPEED,
PAUSE,
ADSR,2,
LENGTH,4*SPEED,
6,
PAUSE,
ADSR,1,
6,
PAUSE,
LENGTH,12*SPEED,
11,
LENGTH,4*SPEED,
PAUSE,
END};

static tm_ubyte _seq9[]={
LENGTH,1*SPEED,
47,
LENGTH,7*SPEED,
51,
LENGTH,8*SPEED,
51,
51,
LENGTH,4*SPEED,
49,
47,
LENGTH,1*SPEED,
47,
LENGTH,3*SPEED,
52,
LENGTH,4*SPEED,
PAUSE,
52,
PAUSE,
ADSR,4,
LENGTH,16*SPEED,
40,
ADSR,0,
LENGTH,1*SPEED,
47,
LENGTH,3*SPEED,
51,
LENGTH,4*SPEED,
PAUSE,
51,
PAUSE,
ADSR,4,
LENGTH,16*SPEED,
39,
ADSR,0,
LENGTH,1*SPEED,
42,
LENGTH,3*SPEED,
49,
LENGTH,4*SPEED,
PAUSE,
49,
PAUSE,
ADSR,4,
LENGTH,12*SPEED,
47,
ADSR,0,
LENGTH,4*SPEED,
47,
LENGTH,1*SPEED,
47,
LENGTH,7*SPEED,
51,
LENGTH,8*SPEED,
51,
51,
LENGTH,4*SPEED,
49,
47,
LENGTH,1*SPEED,
47,
LENGTH,3*SPEED,
52,
LENGTH,4*SPEED,
PAUSE,
52,
PAUSE,
ADSR,4,
LENGTH,16*SPEED,
40,
ADSR,0,
LENGTH,4*SPEED,
40,
42,
43,
PAUSE,
43,
42,
40,
PAUSE,
47,
ADSR,1,
LENGTH,1*SPEED,
35,
PAUSE,
35,
PAUSE,
LENGTH,2*SPEED,
35,
PAUSE,
35,
PAUSE,
ADSR,2,
35,
PAUSE,
35,
PAUSE,
ADSR,3,
35,
PAUSE,
35,
PAUSE,
END};

static tm_ubyte _seq10[]={
LENGTH,4*SPEED,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
LENGTH,2*SPEED,
23,
23,
LENGTH,4*SPEED,
23,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
LENGTH,2*SPEED,
23,
23,
LENGTH,4*SPEED,
23,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
LENGTH,2*SPEED,
23,
23,
LENGTH,4*SPEED,
23,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
LENGTH,2*SPEED,
23,
23,
LENGTH,4*SPEED,
23,
23,
20,
20,
20,
PAUSE,
20,
20,
20,
PAUSE,
23,
ADSR,1,
LENGTH,1*SPEED,
23,
PAUSE,
23,
PAUSE,
LENGTH,2*SPEED,
23,
PAUSE,
23,
PAUSE,
ADSR,2,
23,
PAUSE,
23,
PAUSE,
ADSR,3,
23,
PAUSE,
23,
PAUSE,
END};

static tm_ubyte _seq11[]={
LENGTH,4*SPEED,
9,
PAUSE,
6,
PAUSE,
3,
PAUSE,
11,
PAUSE,
4,
PAUSE,
4,
PAUSE,
4,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
11,
PAUSE,
11,
PAUSE,
11,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
4,
PAUSE,
4,
PAUSE,
4,
LENGTH,2*SPEED,
11,
PAUSE,
8,
PAUSE,
4,
PAUSE,
LENGTH,4*SPEED,
9,
PAUSE,
6,
PAUSE,
3,
PAUSE,
11,
PAUSE,
4,
PAUSE,
4,
PAUSE,
4,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
0,
0,
0,
PAUSE,
0,
0,
0,
PAUSE,
ADSR,4,
11,
LENGTH,28*SPEED,
PAUSE,
END};

static tm_ubyte _seq12[]={
LENGTH,2*SPEED,
42,
PAUSE,
41,
PAUSE,
40,
PAUSE,
39,
PAUSE,
ADSR,2,
44,
PAUSE,
43,
PAUSE,
42,
PAUSE,
40,
PAUSE,
47,
PAUSE,
45,
PAUSE,
44,
PAUSE,
42,
PAUSE,
ADSR,1,
49,
PAUSE,
47,
PAUSE,
45,
PAUSE,
44,
PAUSE,
ADSR,0,
52,
PAUSE,
52,
PAUSE,
ADSR,1,
49,
PAUSE,
46,
PAUSE,
ADSR,2,
43,
PAUSE,
40,
PAUSE,
ADSR,3,
37,
PAUSE,
34,
PAUSE,
35,
PAUSE,
36,
PAUSE,
37,
PAUSE,
39,
PAUSE,
LENGTH,12*SPEED,
40,
LENGTH,4*SPEED,
PAUSE,
40,
40,
ADSR,6,
LENGTH,8*SPEED,
41,
ADSR,2,
LENGTH,4*SPEED,
40,
40,
ADSR,6,
LENGTH,8*SPEED,
42,
ADSR,1,
LENGTH,4*SPEED,
40,
40,
ADSR,5,
LENGTH,8*SPEED,
43,
ADSR,1,
LENGTH,4*SPEED,
40,
40,
ADSR,5,
LENGTH,8*SPEED,
44,
ADSR,0,
LENGTH,4*SPEED,
44,
40,
45,
40,
46,
40,
47,
40,
48,
40,
49,
40,
50,
40,
51,
ADSR,2,
LENGTH,2*SPEED,
40,
PAUSE,
END};

static tm_ubyte _seq13[]={
LENGTH,4*SPEED,
PAUSE,
24,
PAUSE,
24,
ADSR,2,
PAUSE,
24,
PAUSE,
24,
PAUSE,
24,
PAUSE,
24,
ADSR,1,
PAUSE,
24,
PAUSE,
24,
24,
ADSR,0,
LENGTH,2*SPEED,
43,
PAUSE,
ADSR,1,
40,
PAUSE,
37,
PAUSE,
ADSR,2,
34,
PAUSE,
31,
PAUSE,
ADSR,3,
28,
PAUSE,
31,
PAUSE,
LENGTH,4*SPEED,
21,
PAUSE,
21,
PAUSE,
20,
PAUSE,
20,
PAUSE,
LENGTH,2*SPEED,
40,
PAUSE,
40,
PAUSE,
ADSR,6,
LENGTH,8*SPEED,
40,
ADSR,2,
LENGTH,2*SPEED,
40,
PAUSE,
40,
PAUSE,
ADSR,6,
LENGTH,8*SPEED,
40,
ADSR,1,
LENGTH,2*SPEED,
40,
PAUSE,
40,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
40,
ADSR,1,
LENGTH,2*SPEED,
40,
PAUSE,
40,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
40,
ADSR,0,
LENGTH,4*SPEED,
32,
40,
33,
40,
34,
40,
35,
40,
36,
40,
37,
40,
38,
40,
39,
PAUSE,
END};

static tm_ubyte _seq14[]={
ADSR,3,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
ADSR,2,
8,
PAUSE,
8,
PAUSE,
6,
PAUSE,
6,
PAUSE,
ADSR,1,
4,
PAUSE,
4,
PAUSE,
9,
ADSR,0,
LENGTH,2*SPEED,
9,
PAUSE,
13,
PAUSE,
16,
PAUSE,
20,
PAUSE,
21,
PAUSE,
ADSR,3,
25,
PAUSE,
25,
PAUSE,
LENGTH,4*SPEED,
11,
PAUSE,
11,
PAUSE,
4,
4,
4,
PAUSE,
LENGTH,2*SPEED,
28,
PAUSE,
28,
PAUSE,
ADSR,6,
LENGTH,8*SPEED,
28,
ADSR,2,
LENGTH,2*SPEED,
28,
PAUSE,
28,
PAUSE,
ADSR,6,
LENGTH,8*SPEED,
28,
ADSR,1,
LENGTH,2*SPEED,
28,
PAUSE,
28,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
28,
ADSR,1,
LENGTH,2*SPEED,
28,
PAUSE,
28,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
28,
16,
16,
16,
16,
16,
16,
16,
LENGTH,4*SPEED,
16,
PAUSE,
END};

static tm_ubyte _seq15[]={
LENGTH,1*SPEED,
40,
LENGTH,3*SPEED,
52,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
52,
PAUSE,
52,
PAUSE,
51,
PAUSE,
50,
PAUSE,
49,
PAUSE,
47,
LENGTH,10*SPEED,
PAUSE,
LENGTH,2*SPEED,
42,
PAUSE,
LENGTH,1*SPEED,
44,
LENGTH,3*SPEED,
47,
LENGTH,8*SPEED,
PAUSE,
LENGTH,2*SPEED,
42,
PAUSE,
LENGTH,1*SPEED,
44,
LENGTH,3*SPEED,
47,
LENGTH,8*SPEED,
PAUSE,
ADSR,0,
LENGTH,1*SPEED,
39,
PAUSE,
40,
PAUSE,
LENGTH,2*SPEED,
44,
PAUSE,
42,
PAUSE,
38,
PAUSE,
32,
PAUSE,
LENGTH,12*SPEED,
33,
LENGTH,4*SPEED,
PAUSE,
END};

static tm_ubyte _seq16[]={
LENGTH,4*SPEED,
PAUSE,
19,
19,
19,
PAUSE,
18,
PAUSE,
18,
PAUSE,
18,
18,
18,
PAUSE,
20,
20,
LENGTH,8*SPEED,
PAUSE,
LENGTH,4*SPEED,
20,
20,
ADSR,0,
LENGTH,1*SPEED,
39,
PAUSE,
40,
PAUSE,
LENGTH,4*SPEED,
44,
42,
38,
32,
PAUSE,
21,
21,
PAUSE,
END};

static tm_ubyte _seq17[]={
LENGTH,4*SPEED,
9,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
11,
PAUSE,
11,
PAUSE,
11,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
4,
LENGTH,12*SPEED,
PAUSE,
LENGTH,4*SPEED,
4,
LENGTH,12*SPEED,
PAUSE,
ADSR,0,
LENGTH,4*SPEED,
4,
PAUSE,
4,
PAUSE,
ADSR,4,
LENGTH,12*SPEED,
9,
LENGTH,4*SPEED,
PAUSE,
END};

static tm_ubyte _seq18[]={
ADSR,2,
LENGTH,2*SPEED,
50,
PAUSE,
33,
PAUSE,
50,
PAUSE,
33,
PAUSE,
LENGTH,1*SPEED,
49,
50,
LENGTH,2*SPEED,
49,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
47,
48,
LENGTH,2*SPEED,
47,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
47,
48,
LENGTH,2*SPEED,
47,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
45,
46,
LENGTH,2*SPEED,
45,
LENGTH,4*SPEED,
PAUSE,
ADSR,0,
LENGTH,2*SPEED,
37,
38,
LENGTH,4*SPEED,
40,
LENGTH,2*SPEED,
37,
38,
LENGTH,4*SPEED,
40,
ADSR,2,
LENGTH,1*SPEED,
47,
48,
LENGTH,2*SPEED,
47,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
45,
46,
LENGTH,2*SPEED,
45,
LENGTH,4*SPEED,
PAUSE,
ADSR,0,
LENGTH,2*SPEED,
37,
38,
LENGTH,4*SPEED,
40,
LENGTH,2*SPEED,
37,
38,
LENGTH,4*SPEED,
40,
ADSR,2,
LENGTH,1*SPEED,
47,
48,
LENGTH,2*SPEED,
47,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
45,
46,
LENGTH,2*SPEED,
45,
LENGTH,4*SPEED,
PAUSE,
ADSR,0,
LENGTH,2*SPEED,
38,
40,
LENGTH,4*SPEED,
42,
LENGTH,2*SPEED,
38,
40,
LENGTH,4*SPEED,
42,
ADSR,2,
LENGTH,2*SPEED,
50,
PAUSE,
33,
PAUSE,
50,
PAUSE,
33,
PAUSE,
LENGTH,1*SPEED,
49,
50,
LENGTH,2*SPEED,
49,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
47,
48,
LENGTH,2*SPEED,
47,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
47,
48,
LENGTH,2*SPEED,
47,
LENGTH,4*SPEED,
PAUSE,
LENGTH,1*SPEED,
45,
46,
LENGTH,2*SPEED,
45,
LENGTH,4*SPEED,
PAUSE,
ADSR,0,
LENGTH,2*SPEED,
37,
38,
LENGTH,4*SPEED,
40,
LENGTH,2*SPEED,
37,
38,
LENGTH,4*SPEED,
40,
ADSR,2,
LENGTH,1*SPEED,
33,
35,
LENGTH,2*SPEED,
37,
LENGTH,4*SPEED,
38,
ADSR,1,
40,
42,
43,
45,
ADSR,0,
47,
49,
50,
PAUSE,
54,
PAUSE,
END};

static tm_ubyte _seq19[]={
ADSR,3,
LENGTH,4*SPEED,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
21,
ADSR,2,
26,
28,
ADSR,1,
30,
31,
33,
ADSR,0,
35,
37,
38,
PAUSE,
42,
PAUSE,
END};

static tm_ubyte _seq20[]={
ADSR,3,
LENGTH,4*SPEED,
2,
PAUSE,
9,
PAUSE,
2,
PAUSE,
9,
PAUSE,
1,
PAUSE,
9,
PAUSE,
4,
PAUSE,
9,
PAUSE,
1,
PAUSE,
9,
PAUSE,
4,
PAUSE,
9,
PAUSE,
2,
PAUSE,
9,
PAUSE,
2,
PAUSE,
9,
PAUSE,
2,
PAUSE,
9,
PAUSE,
2,
PAUSE,
9,
PAUSE,
1,
PAUSE,
9,
PAUSE,
4,
PAUSE,
9,
PAUSE,
9,
LENGTH,12*SPEED,
PAUSE,
ADSR,1,
LENGTH,4*SPEED,
19,
21,
ADSR,0,
23,
25,
26,
PAUSE,
30,
PAUSE,
END};

static tm_ubyte _seq21[]={
LENGTH,4*SPEED,
50,
LENGTH,12*SPEED,
PAUSE,
END};

static tm_ubyte _seq22[]={
LENGTH,4*SPEED,
38,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
33,
END};

static tm_ubyte _seq23[]={
LENGTH,4*SPEED,
26,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
21,
END};

static tm_ubyte _seq24[]={
LENGTH,4*SPEED,
50,
LENGTH,12*SPEED,
PAUSE,
ADSR,4,
LENGTH,1*SPEED,
46,
LENGTH,7*SPEED,
47,
LENGTH,1*SPEED,
46,
LENGTH,7*SPEED,
47,
LENGTH,1*SPEED,
46,
LENGTH,7*SPEED,
47,
LENGTH,1*SPEED,
46,
LENGTH,7*SPEED,
47,
ADSR,0,
LENGTH,2*SPEED,
35,
PAUSE,
35,
37,
38,
PAUSE,
40,
PAUSE,
42,
ADSR,4,
LENGTH,6*SPEED,
PAUSE,
44,
LENGTH,1*SPEED,
42,
44,
44,
LENGTH,7*SPEED,
45,
LENGTH,1*SPEED,
44,
LENGTH,7*SPEED,
45,
LENGTH,1*SPEED,
44,
LENGTH,7*SPEED,
45,
LENGTH,1*SPEED,
44,
LENGTH,7*SPEED,
45,
ADSR,0,
LENGTH,2*SPEED,
33,
PAUSE,
33,
35,
36,
PAUSE,
38,
PAUSE,
40,
ADSR,4,
LENGTH,6*SPEED,
PAUSE,
42,
LENGTH,1*SPEED,
40,
42,
42,
LENGTH,7*SPEED,
43,
LENGTH,1*SPEED,
42,
LENGTH,7*SPEED,
43,
LENGTH,1*SPEED,
42,
LENGTH,7*SPEED,
43,
LENGTH,1*SPEED,
42,
LENGTH,7*SPEED,
43,
ADSR,0,
LENGTH,2*SPEED,
31,
PAUSE,
31,
33,
35,
PAUSE,
36,
PAUSE,
LENGTH,4*SPEED,
38,
PAUSE,
ADSR,4,
LENGTH,6*SPEED,
40,
LENGTH,1*SPEED,
38,
40,
LENGTH,2*SPEED,
42,
LENGTH,6*SPEED,
PAUSE,
40,
LENGTH,1*SPEED,
38,
40,
LENGTH,2*SPEED,
42,
LENGTH,6*SPEED,
PAUSE,
40,
LENGTH,1*SPEED,
38,
40,
LENGTH,4*SPEED,
42,
PAUSE,
42,
PAUSE,
LENGTH,1*SPEED,
42,
LENGTH,3*SPEED,
54,
LENGTH,12*SPEED,
PAUSE,
END};

static tm_ubyte _seq25[]={
LENGTH,4*SPEED,
38,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
30,
ADSR,1,
LENGTH,4*SPEED,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
23,
PAUSE,
19,
19,
21,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
PAUSE,
21,
21,
PAUSE,
25,
25,
23,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
PAUSE,
23,
23,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
23,
ADSR,1,
LENGTH,4*SPEED,
21,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
23,
ADSR,1,
LENGTH,4*SPEED,
21,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
23,
ADSR,1,
LENGTH,4*SPEED,
21,
PAUSE,
LENGTH,2*SPEED,
30,
LENGTH,6*SPEED,
PAUSE,
LENGTH,2*SPEED,
42,
LENGTH,14*SPEED,
PAUSE,
END};

static tm_ubyte _seq26[]={
LENGTH,4*SPEED,
26,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
18,
ADSR,1,
LENGTH,4*SPEED,
11,
PAUSE,
11,
PAUSE,
11,
PAUSE,
11,
PAUSE,
11,
PAUSE,
11,
PAUSE,
11,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
4,
ADSR,1,
LENGTH,4*SPEED,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
9,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
2,
ADSR,1,
LENGTH,4*SPEED,
7,
PAUSE,
7,
PAUSE,
7,
PAUSE,
7,
PAUSE,
7,
PAUSE,
7,
PAUSE,
7,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
7,
ADSR,1,
LENGTH,4*SPEED,
6,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
7,
ADSR,1,
LENGTH,4*SPEED,
6,
PAUSE,
ADSR,5,
LENGTH,8*SPEED,
7,
ADSR,1,
LENGTH,4*SPEED,
6,
LENGTH,28*SPEED,
PAUSE,
END};

static tm_ubyte _seq27[]={
LENGTH,4*SPEED,
50,
PAUSE,
END};

static tm_ubyte _seq28[]={
LENGTH,4*SPEED,
38,
PAUSE,
END};

static tm_ubyte _seq29[]={
LENGTH,4*SPEED,
26,
PAUSE,
END};

static tm_ubyte *seq_tab[]={
_seq0,_seq1,_seq2,_seq3,_seq4,_seq5,_seq6,_seq7,_seq8,_seq9,
_seq10,_seq11,_seq12,_seq13,_seq14,_seq15,_seq16,_seq17,_seq18,_seq19,
_seq20,_seq21,_seq22,_seq23,_seq24,_seq25,_seq26,_seq27,_seq28,_seq29,
NULL};

static tm_ubyte _adsr0[]={10,13,15,15,15,14,14,13,END};
static tm_ubyte _adsr1[]={9,12,14,14,14,13,13,12,END};
static tm_ubyte _adsr2[]={8,12,13,13,13,12,12,11,END};
static tm_ubyte _adsr3[]={8,11,12,12,12,11,END};
static tm_ubyte _adsr4[]={
10,13,15,15,15,14,14,13,13,12,12,12,11,11,11,10,10,10,10,9,9,9,9,8,END};
static tm_ubyte _adsr5[]={
9,12,14,14,14,13,13,12,12,11,11,11,10,10,10,9,9,9,9,8,END};
static tm_ubyte _adsr6[]={
8,12,13,13,13,12,12,11,11,10,10,10,9,9,9,9,8,END};
static tm_ubyte *adsr[]={
_adsr0,_adsr1,_adsr2,_adsr3,_adsr4,_adsr5,_adsr6};

static tm_ubyte _arp0[]={1,0,END};
static tm_ubyte _arp1[]={2,0,END};
static tm_ubyte _arp2[]={2,0,END};
static tm_ubyte *arp[]={_arp0,_arp1,_arp2};

static tm_ubyte _vibr0[]={0x80,0x7D,0x80,0x83,LOOP};
static tm_ubyte _vibr1[]={0x80,0x7A,0x80,0x86,LOOP};
static tm_ubyte _vibr2[]={0x80,0x70,0x80,0x90,LOOP};
static tm_ubyte *vibr[]={_vibr0,_vibr1,_vibr2};

/*----------------------------------------------------------------*/

static tm_ubyte *tab[3];		/* zeiger auf tabelle	*/
static tm_ubyte *seq[3];		/* zeiger auf sequenz	*/
static tm_ubyte l[3],ll[3];		/* notendauer		*/
static tm_ubyte t[3];			/* notenhhe		*/
static tm_ubyte *a[3],*ao[3];		/* adsr			*/
static tm_ubyte *ar[3],*aro[3];		/* arpeggio		*/
static tm_ubyte *vi[3],*vio[3];		/* vibrato		*/

#define GISELECT (*((unsigned char *)0xFFFF8800L))
#define GIWRITE  (*((unsigned char *)0xFFFF8802L))
#define GIREAD   (*((unsigned char *)0xFFFF8800L))

static void work(int ch)
{
  int div;

  if (l[ch]==0)
  {
    for (;;)
    {
      t[ch]=*seq[ch]++;
      if (t[ch]==END)
      {
        if (*tab[ch]==END)
          tab[ch]=tab_tab[ch]+(*++tab[ch]);
        seq[ch]=seq_tab[*tab[ch]++];
      }
      else if (t[ch]==STOP)
      {
        seq[ch]--;
        return;
      }
      else if (t[ch]==LENGTH)
        ll[ch]=*seq[ch]++;
      else if (t[ch]==ADSR)
        ao[ch]=adsr[*seq[ch]++];
      else if (t[ch]==ARPEGGIO)
        aro[ch]=arp[*seq[ch]++];
      else if (t[ch]==VIBRATO)
        vio[ch]=vibr[*seq[ch]++];
      else
        break;
    }
    l[ch]=ll[ch];
    a[ch]=ao[ch];
    ar[ch]=aro[ch];
    vi[ch]=vio[ch];
  }

  l[ch]--;
  if (*a[ch]!=END && t[ch]!=PAUSE)
  {
    GISELECT=8+ch;
    GIWRITE=*a[ch]++;
  }
  if (*ar[ch]==END)
    ar[ch]--;
  else if (*ar[ch]==LOOP)
    ar[ch]=aro[ch];
  if (*vi[ch]==END)
    vi[ch]--;
  else if (*vi[ch]==LOOP)
    vi[ch]=vio[ch];
  if (t[ch]==PAUSE)
  {
    GISELECT=8+ch;
    GIWRITE=0;
  }
  else
  {
    div=divider[t[ch]+*ar[ch]++];
    div+=*vi[ch]++;
    div-=0x80;
    GISELECT=0+ch+ch;
    GIWRITE=(unsigned char)div;
    GISELECT=1+ch+ch;
    GIWRITE=(unsigned char)(div>>8);
  }
}

static int my_timer(void)
{
  work(0);
  work(1);
  work(2);
  return(0);
}

static tm_ubyte init[]={
0,0,1,0, 2,0,3,0, 4,0,5,0, 6,0, 7,0xF8, 8,0,9,0,10,0, 0xFF,0};
static tm_ubyte exit[]={
0,0,1,0, 2,0,3,0, 4,0,5,0, 6,0, 7,0xFF, 8,0,9,0,10,0, 0xFF,0};

static int  (*old_timer)();

static void sound_init(void)
{
  int  ticks;

  Dosound(init);
  l[0]=0;
  l[1]=0;
  l[2]=0;
  tab[0]=tab_tab[0];
  tab[1]=tab_tab[1];
  tab[2]=tab_tab[2];
  seq[0]=seq_tab[*tab[0]++];
  seq[1]=seq_tab[*tab[1]++];
  seq[2]=seq_tab[*tab[2]++];
  vex_timv(vdi_handle,my_timer,&old_timer,&ticks);
}

static void sound_exit(void)
{
  int  ticks;

  vex_timv(vdi_handle,old_timer,&old_timer,&ticks);
  Dosound(exit);
}

/*----------------------------------------------------------------*/

int main(void) {
  int  i,work_in[11],work_out[57];

  puts("\033H");
  if (appl_init()<0)
    return(1);
  vdi_handle=graf_handle(&i,&i,&i,&i);
  for (i=0; i<10; work_in[i++]=1);
  work_in[10]=2;
  v_opnvwk(work_in,&vdi_handle,work_out);
  wind_update(BEG_UPDATE);
  graf_mouse(M_OFF,NULL);

  printf("Circa-Speicherbedarf der Sounds: %ld\n",
         (long)seq-(long)divider-sizeof(divider));

  puts("Vor Umsetzen des Vektors:");
  measure();
  measure();

  sound_init();

  puts("Whrend der Sounds (Taste):");
  while (!kbhit())
    measure();
  (void)getch();

  sound_exit();

  puts("Nach Zurcksetzen des Vektors:");
  measure();
  measure();

  graf_mouse(M_ON,NULL);
  wind_update(END_UPDATE);
  v_clsvwk(vdi_handle);
  appl_exit();
  return(0);
}
