/*

  lpj_test.c

*/

#include <ctype.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "lpj.h"

char *msg1[]={"CENTER","  UP  "," DOWN "};
char *msg2[]={"CENTER"," LEFT "," RIGHT"};

#define QUIT (LPJ_JOY_UP|LPJ_JOY_LEFT|LPJ_JOY_FIRE)

main(void) {
  int  lpj;
  char joy,old_joy=-1;

  puts("parallel joystick interface test program");
  puts("(c) 1998 Till Harbaum");
  puts("quit with up/left/fire");

  if ((lpj = open("/dev/lpj" , O_RDONLY ))<0) {
    perror("open /dev/lpj");
    exit(-1);
  }

  do {
    if(read(lpj, &joy, 1)<0)
      perror("read");

    if(old_joy!=joy) {
      printf("\rverical: %s horizontal: %s button: %s",
	     msg1[((joy&LPJ_JOY_UP)?1:0)+((joy&LPJ_JOY_DOWN)?2:0)],
	     msg2[((joy&LPJ_JOY_LEFT)?1:0)+((joy&LPJ_JOY_RIGHT)?2:0)],
	     (joy&LPJ_JOY_FIRE)?"PRESSED ":"RELEASED");
      fflush(stdout);
      old_joy=joy;
    }
  } while((joy&QUIT)!=QUIT);

  close(lpj);  
  puts("");
  return(0);
}
